c  Fortran program to translate the offset file format
c    into jl format
c
c  Each record of edits file looks like
c   X  date1   cause
c 
c  where X is S, T, or N
c  S means skip record
c  N             instrumental fault
c  T             edit due to either tectonic or other causes
c  date1  are either one of two formats
c   yearjdoyhrmn or yearmndahrmv
c  or yearjdoy  or yearmnda
c  
c  Goal is to parse dates into "year doy.decimal" format
c  and output two sets of edits; one identified by N
c                          and the other indentified by T
c
      character*132 string
      character*40, infile, tfile, nfile
      character*1 id
      character*12 date1, date2
      character*20 item(10)
      integer year1, year2
      double precision doy1, doy2,start,stop,doys,doye
      print*,' Input the name of the offset file'
      read(5,100)infile
      print*,' Input the name of the file to dump N offsets (cl)'
      read(5,100)nfile
      print*,' Input the name of the file to dump N and T offsets'
      read(5,100)tfile
100   format(a40)
101   format(a132)
      print*,' Input the start and stop dates of data in jl format'
      print*,'  year doy.decimal  year doy.decimal'
      read(5,*) years,doys,yeare,doye
      start=years*1000. + doys
      stop=yeare*1000. + doye

      open(1,file=infile)
      open(2,file=nfile)
      open(3,file=tfile)
      open(4,file="error.out")
1     continue
      read(1,101,end=90)string

      lenstr=len(string)

      call parse(string,numitems,item)

c
c  examine first letter for an S or #
c 
      if ( (item(1) .ne. 'N' ) .and. (item(1) .ne. 'T') .and.
     &     (item(1) .ne. 'I' ) .and. (item(1) .ne. 'O')  ) then
c   skip record
        go to 1
      end if

      len1=totlen(item(2))
c      len2=totlen(item(3))

c  test to reject dates that are not the correct size
c   program outputs error and stops!
      if (((len1 .ne. 12) .and. (len1 .ne. 8)) ) then

         item(3)='ERROR in format'
         write(4,*)item(1),item(2),item(3)
         stop
      end if

c
c  dates look acceptable; convert to jl format
c
       call conjl(item(2),year1,doy1) 

c       call conjl(item(3),year2,doy2)
c
c   compare times with start and stop times
c
      if ((year1*1000.+ doy1 .ge. start) .and.
     &     (year1*1000.+ doy1 .le. stop)) then
c output the edits
        iflag=0
        if (( item(1) .eq. 'N' ) .or. ( item(1) .eq. 'I')) then
           write(2,105)year1,doy1
           write(3,105)year1,doy1
105        format(1(1x,i4,1x,f15.9))
           iflag=1
        end if
        if (( item(1) .eq. 'T' ) .or. ( item(1) .eq. 'O')) then
          write(3,105)year1,doy1
          iflag=1
        end if
        if (iflag .eq. 0 ) then
c  id is not either N, I, T, or O --- bail!!
          item(3)='Not approved N/T/I/O'
          write(4,*)item(1),item(2),item(1),item(3)
          stop
        end if
      end if


      go to 1

90    continue
      close(1)
      close(2)
      close(3)
      close(4)
      stop
      end
      subroutine conjl(string,year,doy)
c  converts string-date to year, doy.decimal (aka jl format)
      character*20 string
      integer year, da, hr, mn
      double precision doy
      len1=totlen(string)
c parse year

      read(unit = string(1:4), fmt = '(i4)') year
c      print*,' year=', year
c  test for 'j' in fifth column
      if ((string(5:5) .eq. 'j') .or. (string(5:5) .eq. 'J')) then
c   DOY format
         read( unit = string(6:8), fmt = '(i3)') jul
      else
c  Month and day format
        read( unit = string(5:8), fmt = '(2i2)') mn, da
c        print*,'mn=', mn,' da=',da

        call date2day(year,mn,da,iday)
c        print*,' iday=',iday
        call inv_jul_time(iday,nyr,jul)
c        print*,' jul=',jul
   
      end if
      hr=0
      mn=0
      if ( len1 .eq. 12 ) then
         read( unit = string(9:12), fmt = '(2i2)') hr, mn
c         print*,' hr=',hr,' mn=',mn
      end if
      doy=float(jul) + float(hr)/(24.d+0) +
     &   float(mn)/((24.d+0)*(60.d+0))



      return
      end
      subroutine date2day(yr,mon,date,day)
      integer yr,date,day,mon
      dimension mnth(12)
      data (mnth(i),i=1,12)/0,31,59,90,120,151,181,212,243,273,304,334/
c
      yr=yr-1900
 
      day=0
      day=int(yr-60)*365
      if (yr .le. 60) go to 3
      day= day+1
      if (yr .le. 64) go to 3
      day= day+1
      if (yr .le. 68) go to 3
      day= day+1
      if (yr .le. 72) go to 3
      day= day+1
      if (yr .le. 76) go to 3
      day= day+1
      if (yr .le. 80) go to 3
      day= day+1
      if (yr .le. 84) go to 3
      day=day+1
      if (yr .le. 88) go to 3
      day=day+1
      if (yr .le. 92) go to 3
      day=day+1
      if (yr .le. 96) go to 3
      day=day+1
      if (yr .le. 100) go to 3
      day=day+1
      if (yr .le. 104) go to 3
      day=day+1
      if (yr .le. 108) go to 3
      day=day+1
      if (yr .le. 112) go to 3
      day=day+1     
      if (yr .le. 116) go to 3
      day=day+1     

3     day=day+mnth(mon)+date
      if (((yr .eq. 80) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     &  (yr .eq. 72) .or. (yr .eq. 76) .or. (yr .eq. 80) .or.
     & (yr .eq. 84) .or.(yr .eq. 88)
     &  .or. (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100)
     & .or. (yr .eq. 104) .or. (yr .eq. 108) .or. (yr .eq. 112)
     & .or. (yr .eq. 116))
     1  .and. (mon .ge. 3)) go to 10
      go to 11
10    day= day+1
       
11    continue
      yr=yr+1900
      return
      end
      subroutine inv_jul_time(itime,nyr,jul)
c converts day number since jan 1, 1960 back to julian day and year
c
c  itime is number of days since Jan 1, 1960
      dimension nyear(60),nleap(60)
      nx=60
        do 1 i=1,nx
        nleap(i)=1+(i-1)*4
1       continue
        j=1
        ncnt=0
        do 2 i=1,nx
        if (i .eq. nleap(j)) then
           ncnt=ncnt+366
           j=j+1
        else
          ncnt=ncnt+365
        end if
        nyear(i)=ncnt
c        print*,i,nyear(i)
2       continue
      k=1
      nyr=1960
c      if (itime .lt. nyear(1)) then
      if (itime .le. nyear(1)) then
        jul=itime
        return
      end if
      k=2
      nyr=nyr+1
3     continue
      if ((itime .gt. nyear(k-1)) .and. (itime .le. nyear(k))) then
        jul=itime-nyear(k-1)
        return
      else
        k=k+1
        nyr=nyr+1
        go to 3
      end if
      end
 

      function totlen(string)
c  figures out the total length of string to first blank character
c
      character*20 string
      len1=len(string)
      i=1
1     continue
      if ( i .le. len1) then
         if (string(i:i) .eq. ' ') then
           totlen=i-1
           go to 10
         end if
         i=i+1
         go to 1
      end if
10    continue
      return
      end
         
C***** parse.f *****
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine parse (string, numitems, item)
c     Extracts items separated by blanks from a string, and
c      returns them left-justified in NUMITEMS separate ITEM strings.
 
      character*(*)  string, item(*)
      character*132  tempstring
 
      numitems = 0
      lenstr = len(string)
      tempstring = string
      istart = 1
 
 10   do 50 i = istart, lenstr
      if(tempstring(i:i) .ne. ' ') then
        ibegin = i
        nextblank = index(tempstring(i:lenstr), ' ')
        if (nextblank.eq.0) then
          iend = lenstr
          numitems = numitems + 1
          item (numitems) = tempstring(ibegin:iend)
          goto 90
        else
          iend = nextblank + (i-1) -1
          numitems = numitems + 1
          item (numitems) = tempstring(ibegin:iend)
          istart = iend + 1
          goto 10
        endif
      endif
 50   continue
 
 90   return
      end

