c  Dated late March 2005
c computes maximum likelyhood estimates of random walk and instrument
c   noise
c  uses colored noise  P = Po /(((alpha/2*pi)^n + f ^ n)) Plus white noise
c
c  Plus a second function of Power law noise  P/f^n
c    
c  Plus Bandpass filted noise
c      
c
c USES FRACTIONAL DIFFERENCES!!
c  USES decimation of covariance matrix to deal with un-evenly spaced data
c
c  uses amoeba routine twice to find optimal solution
c   seems to work well!
c
c  option added to decimate data in weird ways....
c
c best way to run is to first fix exponent to 2.0 and estimate random-walk
c   and white noise components, then run a second time using the optimal
c  values of random-walk, white noise as a starting solution
c
c  modified est_col_noise4b to allow for band-passed filtered
c   noise
c
c  replace choldc and svd stuff with LAPACK routines
c
c  modified calculation of covariance for power law so that
c   it doesn't blow-up when white noise is zero
c
c  Uses Hadley Johnson method of normalizing the power-law noise
c
c  Uses resampling the data to create power law noise
c
c  Modified to accomodate data with more than one sample per day
c
c  Modified to account for an additional power law noise
c
c  stablized covariance matrix so that power law noise with exp <=2.5
c   and with no white noise are NOT singular
c
c
c  Modified Jan 2004 to:
c    1)  should compile both with IFC and G77 fortran compilers
c    2)  Input auxillary data such as atmospheric pressure to
c       use with dilatometer data
c    3)  Allow estimate of size of exponential; assumed fixed time-constant
c          A*(1 - exp (-t/tau) )
c
c  March 2004  Bug fixes
c    1)  Noted that 'nominal value' and its standard deviation was wrong---proble
c     rooted in first row (or column) of power law covariance not being ZERO
c       Note---this might affect singularity of high index power law noise..
c       set kswitch0=1
c    2) GM noise  noted that time of Zero lag had non-unity multiplier for power law noise
c        fixed with shift of index of GM.
c    3) Fixed second bug with GM noise; if alpha*ts >1, yielded singular covariance matrices
c       since 1-alpha*ts was negative!   replace by exp(-ts*alpha*j)
c
c  March 2004
c    1)  Program searchs for best time constant (tau) in exponential in A*(1 - exp (-t/tau))
c         uses downhill simplex for search; does search at every step when estimating covariance
c    2)  Also, if specified, searchs for best time constant for Omori's Law A*log10(1 + t/tau)
c    3) The time constants of the exponents are limited to fall between 0.0001 and 100. years
c
c  Oct/Nov 2004/Users/langbein/proglib/Strain/Progs/est_noise6acX.f
c    1)  modified the Omori Law equation to A*log10(tau + t ) where tau and t are units of years.
c    for small tau, the rate become  A/(ln(10)*t)
c    2)  Modified the 'rate change' so that rate change is specified for a range in time.
c
c  March 2006  bug fixs
c   1) in subroutine "output";  did not parse the amplitude of the "exponential/omori"
c     terms correctly; fixed
c   2) for strain data where there are lots of unknowns (tides, pressure, exponentials),
c       a)  Found that chi^2 became negative!
c       b)  In estimating model, change ssyev from single to double precision
c       c)  Found that work area for svd (ssyev) was dimension too small; increase from 500 
c         to 5000; this seem to fix many of the problems; but some still exist
c       Never completely solved this problem; suspect that part of the problem is
c      that the data have power law index close to 3 which is a very unstable problem!
c
c  May 2007  fixed bug sorting out the pressure variable and the exponential terms;
c       However, currently, the error bar on tau for the exponential is not output correctly---
c      it seems okay though in the list of ai=, Anorm=, sqrt(ai);

c  October 2007;  Fix error with of time constant for omori law and exponential
c    Originally, I forgot to include the amplitude term
c
c  February 2008:  Fixed bug associated with small (30 second sampling) intervals
c                 Inconsistent double precision of time --- affected compilation with gfortran 
c                  (seem to be ok with g95 and gfortran)
c  February 2008: Added normalization to rate change to stablize the A matrix

c
      character*3 net,instname(30),netx
      character*132 string,filename
      character*8 bsta(82), line(82), header(9)
      character*1 ans
      integer instnum(30),insol(30),intot(30),infunc(30)
      integer instart(30),instop(30)
      real inparam(30,10)
      character*7 choice(10),exp_choice(10),exp_type(10)
      dimension ran1(65536),ran2(65536),ran3(65536),ran4(65536)
      double precision t_start,t_stop,rat_chg1(82),per(82),off(82),
     & dest(82),timex,t_year(8103),texp(10),tpress,dtime(8103),
     & dtime_orig(8103),rat_chg2(82), dec_timed,fjul,fjul1,fjul2,
     & t(8103),rat_chng_norm(82)
      dimension az(82),rc(20),d(8103),A(8103,82)
      dimension d_orig(8103),A_orig(8103,82),t_orig(8103)
      dimension res(8103),covinv(8103,8103),covar(8103,8103),x(82),
     &   e(82),dith(7),xx(7),bexp(10)
      dimension ambp(8,7),amby(8),acov(8,8),cov(8,8),wz(23)
      dimension vsig(8),vamp1(8),vexp1(8),vamp_bp(8),valpha(8),vamp2(8),
     & vexp2(8)
      dimension covarpl1(8103,8103),covarpl2(8103,8103),
     & covarbp(8103,8103)
      dimension press(8103),aux_norm(82)
c      common covarpl1 ,covarbp,covarpl2

      data (rc(i),i=1,17)/5.58,0.0,6.43,5.58,7.21,
     & 9.06,9.42,3.7,0.0,0.0,-25.2,-24.3,-24.19,0.,-28.19
     &, 0.0,-7.7/
      data (vsig(i),i=1,8)/0.7,1.2,1.2,1.2,0.7,1.2,1.2,0.7/
      data (vamp1(i),i=1,8)/1.95,1.95,0.3,0.3,0.3,0.3,1.95,1.95/
      data (vexp1(i),i=1,8)/0.4,-0.4,-0.4,-0.4,-0.4,-0.4,0.4,-0.4/
      data (valpha(i),i=1,8)/4.5,0.35,4.5,4.5,4.5,4.5,0.35,4.5/
      data (vamp_bp(i),i=1,8)/0.55,1.79,0.55,1.79,0.55,1.79,0.55,0.55/
      data (vamp2(i),i=1,8)/2.31,0.26,2.31,0.26,0.26,0.26,2.25,0.26/
      data (vexp2(i),i=1,8)/-0.6,-0.6,0.6,0.6,-0.6,-0.6,0.6,0.6/
      max_time=65536
      max_parm=82
      max_data=8103
      max_mod=82
       print*,' Program estimates the power spectral density (PSD)'
       print*,'  of data.  PSD functions can be a combination of:'
       print*,'  1) white noise'
       print*,'   2) Simple power law noise P/f^n'
       print*,'  3) a Gauss Markov version P/(fa^n + f^2)'
       print*,'      where fa=alpha/2*pi'
       print*,'  4) A second power law'
       print*,'  5) Band-pass filtered noise'
       print*,' '
       print*,' While estimating the PSD function, program also',
     &     ' estimates'
       print*,'  various parameters that describe the time series',
     &     ' including'
       print*,'  1) DC term'
       print*,'  2) rate'
       print*,'  3) sinusoidal amplitudes of specified frequencies'
       print*,'  4) rate changes'
       print*,'  5) offset'
       print*,' '
       print*,' Program can handle data in various formats including'
       print*,'   2-color EDM data'
       print*,' '

      open(23,file='seed.dat')
      open(12,file='max.out')
      open(13,file='model.out')
      open(14,file='model.dat')
      open(15,file='max.dat')
      read(23,*)iseed
c      call instradj_read(numinst,instname,instnum,instart,instop,
c     & insol,intot,infunc,inparam)
c

      print*,'Input the data type for automatic processing'
      print*,' most users can will use otr otd or otx'
      print*,' otr=data, such as inferred monument displacements'
      print*,'       format of yr, julian day, data, error bar'
      print*,' otd=data, such as inferred monument displacements'
      print*,'       format of yrmoda,  data, error bar'
      print*,' otx=data, such as inferred monument displacements'
      print*,'       format of yr mo da,  data, error bar'
c      print*,' tmr=tmeter data in general'
c      print*,' pkf=cmeter at parkfield'
c      print*,' mam=tmeter at mammoth'
c      print*,' sca=tmeter in southern cal'
      read(5,*)net
      if ((net .ne. 'pkf') 
     & .and.  (net .ne. 'otr') .and.
     &  (net .ne. 'otd') .and. (net .ne. 'tmr') 
     &   .and. (net .ne. 'otx')) then
        print*,' code for network not in list'
        print*,'otr otx otd tmr pkf'
        stop
      end if
      print*,' input number of time series'
      print*,'   program will estimate only one set of PSD functions'
      read(5,*)nbt
      print*,' input the period of interest'
      if (net .eq. 'otr') then
        print*,' start and stop times; year julian_day year julian_day'
        print*,'  "julian day" may be decimal day'
        read(5,*)yr1,fjul1,yr2,fjul2
        call jul2day(int(yr1),int(fjul1),iday)
c days since 1960
        t_start=float(iday)+fjul1-int(fjul1)

        call jul2day(int(yr2),int(fjul2),iday)
c days since 1960
        t_stop=float(iday)+fjul2-int(fjul2)
      else
        print*,' start and stop times; year mn da  year mn da'
        print*,'   "da" may be a decimal day'
        read(5,*) yr1,mn1,day1,yr2,mn2,day2
        call date2day(int(yr1),int(mn1),int(day1),iday)
        t_start=float(iday)+day1-int(day1)
        call date2day(int(yr2),int(mn2),int(day2),iday)
        t_stop=float(iday)+day2-int(day2)
      end if
      print*,' Day numbers from 1960 ',t_start,t_stop
      print*,' '
      print*,' Input the parameters of time series to be estimated'
      print*,' '
      print*,' Will rate be estimated? y/n'
      read(5,*)ans
      nrate=0
      if (ans .eq. 'y') nrate=1
      print*,' Rate changes:'
      print*,'  time is the "hinge point"'
      print*,' Input the number of rate changes in data'
      read(5,*)n_rat_chg
      if (n_rat_chg .gt. max_parm) then
         print*,' Number of parmeters exceed limit of', max_parm
         stop
      end if
      if (n_rat_chg .ne. 0) then
        do 9 i=1,n_rat_chg
        print*,' Input the time interval ',
     &  '(year jul_day year jul_day) or ',
     & '(year month day year month day) of', i,
     &  ' rate change'
        if (net .eq. 'otr') then
          read(5,*)yr,fjul,yr2,fjul2
          call jul2day(int(yr),int(fjul),iday)
          rat_chg1(i)=float(iday)+fjul-int(fjul)
          call jul2day(int(yr2),int(fjul2),iday)
          rat_chg2(i)=float(iday)+fjul2-int(fjul2)
        else
          read(5,*)yr,mn,da,yr2,mn2,da2
          call date2day(int(yr),int(mn),int(da),iday)
          rat_chg1(i)=float(iday)+da-int(da)
          call date2day(int(yr2),int(mn2),int(da2),iday)
          rat_chg2(i)=float(iday)+da2-int(da2)
        end if        
        print*,' Rate change between ',rat_chg1(i), rat_chg2(i)
        if (rat_chg1(i) .ge. t_stop) then
           print*,' rate change beyond end of time series'
           stop
        end if
        rat_chng_norm(i)=(rat_chg2(i)-rat_chg1(i))/365.25
        print*,' Normalization of rate change is:', rat_chng_norm(i)
9     continue
      end if
      print*,' '
      print*,' Input the number of periodicities in the data'
      read(5,*)nper
      if (nper .gt. max_parm) then
         print*,' Number of parmeters exceed limit of', max_parm
         stop
      end if
      if (nper .ne. 0) then
         do 111 i=1,nper
         print*,' Input the period (in days) of ', i,' period'
         read(5,*)per(i)
111        continue
      end if
      print*,' '
      print*,' Offset:  specify first day after offset'
      print*,' Input the number of offsets'
      read(5,*)noff
      if (noff .gt. max_parm) then
         print*,' Number of parmeters exceed limit of', max_parm
         stop
      end if
      if (noff .ne. 0) then
        do 211 i=1,noff
        print*,' Input the time (year jul_day) or (year month day)',
     &        ' of ',i,' offset'
        if (net .eq. 'otr') then
          read(5,*)yr,fjul
          call jul2day(int(yr),int(fjul),iday)
          off(i)=float(iday)+fjul-int(fjul)
        else
          read(5,*)yr,mn,da
          call date2day(int(yr),int(mn),int(da),iday)
          off(i)=float(iday)+da-int(da)
        end if        
        print*,' Offset at ',off(i)
        if (off(i) .ge. t_stop) then
           print*,' Offset beyond end of time series'
           stop
        end if
211   continue
      end if
c  
c  
      print*,' '
      print*,' Input the number of exponentials in time series'
      read(5,*) n_exp
      if (n_exp .ne. 0) then
        do 311 i=1,n_exp
          print*,' Input the time (year jul_day) or (year month day)',
     &        ' of ',i,' exponential'
        if (net .eq. 'otr') then
          read(5,*)yr,fjul
          call jul2day(int(yr),int(fjul),iday)
          texp(i)=float(iday)+fjul-int(fjul)
        else
          read(5,*)yr,mn,da
          call date2day(int(yr),int(mn),int(da),iday)
          texp(i)=float(iday)+da-int(da)
        end if        
        print*,' Exponential starting at ',texp(i)
        if (texp(i) .ge. t_stop) then
           print*,' exponential beyond end of time series'
           stop
        end if     
        print*,' Input the time constant in years and fix/float'
        read(5,*)bexp(i),exp_choice(i) 
        print*,' Input the type of function; e for 1-exp(-t/tau)'
        print*,'      or                     o for log10(tau + t)'
        print*,'      or                     m for log10(1.0 + t/tau)'
        read(5,*)exp_type(i)
311     continue
      endif
      nexp_fix=0
      if (n_exp .ne. 0) then
      do  141 k=1,n_exp
      if (exp_choice(k) .eq. 'fix    ') nexp_fix=nexp_fix+1
141   continue
      end if
      print*,' The number of exponential time constants that',
     & ' are fixed:', nexp_fix
c
c  input the data and construc the A matrix
c
      ic=0
      rate_norm=((t_stop-t_start)/2.)/365.25
      print*,' rate renomalization is ',rate_norm
      do 50 i=1,nbt
        print*,' Input the format style of baseline data',
     &   ' (otr, otx, otd, tmr, pkf)'
        read(5,*)netx
        print*,' Input name of file for baseline number ',i
        read(5,1230)filename
        open (21,file=filename)
c  read in the 'header' information of t/cmeter data
        if (netx .eq. 'pkf') then
          read(21,1230) string
          print*,string
1230      format(a132)
          call parse(string,numi,header)
          bsta(i)=header(1)
          line(i)=header(5)
          read(21,506)dest(i),az(i),zen,hrd
          read(21,504)(header(j),j=1,7)
          print*,bsta(i),line(i)
        end if
        if (netx .eq. 'tmr') then
          read(21,504) bsta(i),line(i),(header(j),j=1,7)
          print*,bsta(i),line(i)
          read(21,506)dest(i),az(i),zen,hrd
504       format(9a8)
506       format(d15.8,f7.1,f8.3,f6.2)
          zen=304.8*sin(zen*3.1415926/180.)
        end if
c  loop to input the actual data
3       continue
        if (netx .eq. 'pkf') then
c  for Parkfield 'cmeter' data
          read (21,5080)iyr,mn,idate,it1,it2,icon,ir
     &    ,hr,dist,sig,num
5080      format (i3,2i3,1x,2i2,2(1x,i2),f7.2,f7.2,f5.2,i3)
          if (iyr .le. 0) go to 50
          iyr=iyr+1900
          call date2day(iyr,mn,idate,itime)
          timex=float(itime)+ float(it1)/24. + float(it2)/(24.*60)          
c  quality control of data
          if ((sig .gt. 3.0*dest(i)*1.0e-07 ) .and.
     &      (sig .gt. 1.5)) go to 3
        end if
        if (netx .eq. 'tmr') then
c  for generic tmeter data
          read(21,508)iyr,mn,idate,it1,it2,icon,ir,hi,hr,dist,sig,num
508       format(3i3,1x,2i2,2i4,2f6.2,f8.2,f6.2,i4)
          if (iyr .le. 0) go to 50
          if (ir .eq. 0) ir=2
          iyr=iyr+1900
          call date2day(iyr,mn,idate,itime)
          timex=float(itime)+ float(it1)/24. + float(it2)/(24.*60)
          if (hr .ge. 10) then
             hi=hi/12.0
             hr=hr/12.0
          end if
          if (hr .eq. 0) hr=hrd
          call instr_adj(dest(i)*1.0e-06,icon,offset,iyr-1900,mn,idate,
     &    numinst,instname,instnum,instart,instop,
     &    insol,intot,infunc,inparam)
          dist=dist+rc(ir)+(hi-hr)*zen+offset
c  quality control of data
          if ((sig .gt. 3.0*dest(i)*1.0e-07 ) .and.
     &      (sig .gt. 1.5)) go to 3
       
       end if
       if (netx .eq. 'otr') then
         read(21,*,end=49)fyr,fjul,dist,sig
         call jul2day(int(fyr),int(fjul),itime)
         timex=float(itime)+fjul-int(fjul)
       end if
       if (netx .eq. 'otd') then
         read(21,*,end=49)fdate,dist,sig
         iyr=int(fdate/10000)
         fdate=fdate-yr*10000
         mn=int(fdate/100)
         fdate=fdate-mn*100
         idate=int(fdate)
         call date2day(iyr,mn,idate,itime)
         timex=float(itime)+fdate-float(idate)
         num=30
         dest(i)=1.0e+09
         icon=21
       end if
       if (netx .eq. 'otx') then
         read(21,*,end=49)fyr,fmn,fdate,dist,sig
         num=30
         icon=0
         dest(i)=10000000.
         call date2day(int(fyr),int(fmn),int(fdate),itime)
         timex=float(itime)+fdate-int(fdate)
       end if
c  is time within range of t_start and t_stop?
      if ((timex .lt. t_start) .or. (timex .gt. t_stop)) go to 3
c  acceptable data at this point
      ic=ic+1
      dtime(ic)=timex-t_start
      t(ic)=timex-t_start
c     XXXXX
c      write(76,*)ic,t(ic) 
      dtime_orig(ic)=dtime(ic)
      d(ic)=dist
c
c  build A matrix
c
c  treat different baselines like offsets
      nc=0
      A(ic,i)=1
      nc=nbt+nc
c  secular rate
      if (nrate .eq. 1) A(ic,nc+1)=(t(ic)/365.25)/rate_norm
       nc=nc+nrate
c  rate changes
      if (n_rat_chg .gt. 0) then
        do 11 k=1,n_rat_chg
        A(ic,nc+k)=0.0
        if ((timex .ge. rat_chg1(k)) .and. 
     &    (timex .lt. rat_chg2(k))) A(ic,nc+k)=
     &     ((timex-rat_chg1(k))/365.25)/rat_chng_norm(k)
        if (timex .ge. rat_chg2(k)) A(ic,nc+k)=
     &     ((rat_chg2(k)-rat_chg1(k))/365.25)/rat_chng_norm(k)
11      continue
      end if
      nc=nc+n_rat_chg
c periodicities
      if (nper .gt. 0) then
        do 12 k=1,nper
c        txx=2.0*3.14159265*t(ic)/per(k)
        txx=2.0*3.141592653589793d0*t(ic)/per(k)
        A(ic,nc+2*k-1)=cos(txx)
        A(ic,nc+2*k-0)=sin(txx)
12      continue
      end if
      nc=nc+2*nper
c  offsets in data
      if (noff .gt. 0) then
        do 13 k=1,noff
        A(ic,nc+k)=0.0
        if (timex .ge. off(k)) A(ic,nc+k)=1
13      continue
      end if

c  offsets in Parkfield cmeter data
c    delineated by change in retro number (ir)
      if (netx .eq. 'pkf') then
      if (ic .eq. 1) then
        ir_last=ir
      else
        if (ir .ne. ir_last) then
          noff=noff+1
          off(noff)=timex
          ir_last=ir
          A(ic,nc+noff)=1.
        end if
      end if
      end if
      nc=nc+noff
c
c  Exponentials
c
c        read(5,*)bexp(i),exp_choice(i) ,texp(i)
       if (n_exp .ne. 0 ) then
       kz=0
       do 14 k=1,n_exp
       if ( exp_choice(k) .eq. 'fix') then
         kz=kz+1
         A(ic,nc+kz)=0.0
         if (timex .gt. texp(k)) then
         if (exp_type(k) .eq. "e")
     &      A(ic,nc+kz)=1.0-exp(-(timex-texp(k))/(bexp(k)*365.25))
         if (exp_type(k) .eq. "o")
c     &      A(ic,nc+kz)=alog10(0.00001 + sngl(timex-texp(k))/
c     &      A(ic,nc+kz)=alog10(1.0 + sngl(timex-texp(k))/
c     &       (bexp(k)*365.25))
     &     A(ic,nc+kz)=alog10(abs(bexp(k)) +  
     &     (sngl(timex-texp(k))/365.25))
         if (exp_type(k) .eq. "m")
     &     A(ic,nc+kz)=alog10(1.0 +
     &       (sngl(timex-texp(k))/365.25)/abs(bexp(k)) )
         end if

       end if
14     continue
       
       end if

      go to 3
49    continue
      close(21)
50    continue
c
c  input the pressure data and add to A matrix
c
      nc=nc+nexp_fix
      print*,' column of A matrix prior to input pressure data', nc
      print*,' Number of files of Auxillary data (pressure)'
      read(5,*)n_file_press
      if (n_file_press .gt. 0) then
        open(88,file='dist_press.dat')
        do 40 i=1,n_file_press

          print*,' Input the format style of baseline data',
     &   ' (otr, otx, otd)'
          read(5,*)netx
          print*,' Input name of file for aux data number ',i
          read(5,1230)filename
          open (22,file=filename)
          print*,' Input the lag in days'
          read(5,*)t_lag
          press_min=999999.
          press_max=-999999.
          sum_press=0.0
          fmiss=-9999.0e+20
c  put missing data symbol in pressure column of A matrix
          do 441 ik=1,ic
441       a(ik,nc+i)=fmiss
44        continue
c  read pressure data
          iflag=0
          if (netx .eq. 'otr') then
            read(22,*,end=48)fyr,fjul,fpress,sig
            call jul2day(int(fyr),int(fjul),itime)
            timex=float(itime)+fjul-int(fjul)
          end if
          if (netx .eq. 'otd') then
            read(22,*,end=48)fdate,fpress,sig
            iyr=int(fdate/10000)
            fdate=fdate-yr*10000
            mn=int(fdate/100)
            fdate=fdate-mn*100
            idate=int(fdate)
            call date2day(iyr,mn,idate,itime)
            timex=float(itime)+fdate-float(idate)
          end if
         if (netx .eq. 'otx') then
           read(22,*,end=48)fyr,fmn,fdate,fpress,sig
           call date2day(int(fyr),int(fmn),int(fdate),itime)
           timex=float(itime)+fdate-int(fdate)
         end if
         tpress=timex-t_lag
         small=1.0e-04



           tpress=tpress-t_start
c           write(66,*)tpress,fpress

c         write(88,*)' pressure read, tpress =',tpress,' iflag=',iflag
c         write(88,*)'t(1) and (t(ic) =',t(1),t(ic)
         if ((tpress .lt. dtime(1)-0.001) .or. 
     &          (tpress .gt. dtime(ic)+0.001)) then
           go to 44
           else
c      time of pressure in range of data

c    scan through data until tpress=t(izz)
c            write(88,*)' '
           izz=1
41         continue
c           diff_time=t(izz)-tpress
           diff_time=dtime(izz)-tpress
           if (abs(diff_time) .le. 0.0007) then
c  THIS is a Match!
c              write(88,*)' Match achieved   izz=',izz,' fpress=',fpress

              a(izz,nc+i)=fpress
              if ((fpress) .gt. press_max)
     &          press_max=fpress
              if ((fpress) .lt. press_min)
     &           press_min=fpress
              sum_press=sum_press+fpress
c      flag is set to go read next pressure measurement
              iflag=1
              
            end if
            if (diff_time .lt. -0.0007) then
c  no patch, time of observation less than time of pressure measurement
c        increment time of observation
              izz=izz+1
              iflag=0
            end if
            if ( (diff_time .gt. 0.0007)) then
 
c  No Match; time of observation exceeds time of pressure data
c              write(88,*)' no match  izz=',izz,' t(izz)=',t(izz),
c     &        ' t(izz-1)=',t(izz-1),
c     &        ' tpress=',tpress

c  go read the next pressure data
              iflag=1
              
            end if
c  determine whether to read the next pressure measurement (iflag=1)
c     or increment the time of the data (iflag=0)
            if (iflag .eq. 1) go to 44
            if (iflag .eq. 0) go to 41

         end if


48    continue
c  all pressure data has been read (end of record)
      close (22)

c  scan A matrix for missing pressure data
       ixx=1
443    continue
          if (a(ixx,nc+i) .eq. fmiss) then
               write(88,*) ' no pressure ixx=',ixx,' t(ixx)=',t(ixx),
     &         'ic-1',ic-1

c  toss-out measurement and shuffle a matrix
               do 42 ik=ixx,ic-1
               d(ik)=d(ik+1)
               t(ik)=t(ik+1)
               if (ik .eq. ixx) then
c                 write(88,*)'ixx=',ixx,' t(ixx)=',t(ixx),a(ik,nc+i),
c     &      'ik+1=',ik+1,a(ik+1,nc+i)
               end if
                do 43 jk=1,nc+i
                a(ik,jk)=a(ik+1,jk)
43              continue
42             continue
              ic=ic-1
              ixx=ixx-1
          end if
          ixx=ixx+1
        if (ixx .le. ic) go to 443
       


      aux_norm(i)=(press_max-press_min)
c      aux_norm(i)=1
      ave_press=sum_press/float(ic)
      print*,' Renormalize auxilary data set ',i,' by',aux_norm(i)
      print*,' max press is ', press_max,'   Min press is: ',
     &  press_min,'   Average press is: ', ave_press

      do 47 ik=1,ic
c       write(89,*)t(ik),d(ik),a(ik,nc+i)
       write(88,88890)ik,t(ik),d(ik),a(ik,nc+i),
     &   (a(ik,nc+i)-ave_press)/aux_norm(i)
88890   format(i9,f20.9,3f20.3)
      a(ik,nc+i)=(a(ik,nc+i)-ave_press)/aux_norm(i)
47    continue

      print*,' List of distance vs pressure data ',
     &  'in dist_press.dat'



40    continue
      close (88)
      close (89)
c  end ax

      end if
c  end input of auxillary data
c
      nmod=nbt+nrate+n_rat_chg+2*nper+noff+n_file_press+nexp_fix



      print*,' Number of data read is ',ic
      print*,' Number of model parameters is ',nmod
      
c      open(7,file='prob.out')
c      do 51 i=1,ic
c51    write(7,123)t(i),d(i),(A(i,j),j=1,nmod)
123   format(f15.5,f8.2,82(1x,f8.5))
      if (nmod .gt. max_mod) then
        print*,' Number of model parameters', nmod,
     &  ' exceeds dimension ',max_mod
        stop
      end if
      if (ic .gt. max_data) then
        print*,' Number of  data', ic,
     &  ' exceeds dimension ',max_data
        stop
      end if

c
c  put data and A in cronological order
c
      call chron(max_data,max_mod,ic,nmod,t,dtime,d,A)
      open(7,file='prob2.out')
      do 52 i=1,ic
52    write(7,123)t(i),d(i),(A(i,j),j=1,nmod)
      close (7)
c
c  get statistics on sampling interval
c
      dt_ave=(t(ic)-t(1))/float(ic-1)
      dt_min=999999.
      dt_max=-99999.
      dt_sd=0
      do 53 i=2,ic
        if (t(i)-t(i-1) .gt. dt_max) dt_max=t(i)-t(i-1)
        if (t(i)-t(i-1) .lt. dt_min) dt_min=t(i)-t(i-1)
        dt_sd=dt_sd+ (t(i)-t(i-1) -dt_ave)**2
53    continue
      dt_sd=sqrt(dt_sd/float(ic-2))
      print*, ' '
      print*,' Average Sampling interval:  ',dt_ave, ' days'
      print*,' Standard deviation of Ave. interval: ',dt_sd,' days'
      print*,' Shortest Sampling interval: ',dt_min, ' days'
      print*,' Longest Sampling Interval:  ',dt_max, ' days'
      print*,' '
      print*,' Input the minimum sampling interval in days to use'
      read(5,*)dt_sam
c
c examine measurements times and if there are redundent measurements
c   within period of less than the minimum sampling interval, average
c   those measurements
c
      npts=int((t(ic)-t(1))/dt_sam)+1
      t_len=t(ic)-t(1)
      if (npts .gt. max_time) then
        print*,' Length, in time, of time series is ',npts,
     &   ' exceeds dimension of ',max_time
        stop
      end if
      print*,' Number of points in time series for analysis is',npts
      print*,' '
      print*,' Do you want to get rid of "redundent" data? y/n'
      print*,'  Coupled with minimum sampling interval, this can',
     & ' decimate data.'
      print*,'  Or, in the case of two baselines with measurements at',
     & '  same time,'
      print*,' it can screw-up design matrix AND make the covariance',
     &  ' singular for some cases'
      read(5,*)ans
      if (ans .eq. 'y') 
     &  call redundent(max_time,max_data,max_mod,d,t,dtime,
     &  A,dt_sam,ic,nmod)
      print*,' After resampling data and getting rid of redundent data'
      print*,'  Number of observations is ',ic
      open(7,file='prob1.out')
      do 51 i=1,ic
        t_year(i)=(t(i)-t(1))/365.25d+00
c     XXXXX
c        write(78,*)i,dble(t(i)),dble(t(1)),t_year(i)
      write(7,123)t(i),d(i),(A(i,j),j=1,nmod)
51    continue
      close (7)
c123   format(f15.5,f8.2,30f8.5)
      print*, ' '
      print*,' time, data, and A matrix are in prob1(2).out'
      print*,'  prob1.out has stuff after redundencies are removed'
      print*,'  prob2.out has stuff in cronological order before ',
     &  ' redundancies removed'
      print*,' '

      print*,' Do you want to substitute real data with random',
     &  ' numbers? y/n'
      read(5,*)ans
      if (ans .eq. 'y') then
c  generate random numbers
        open (77,file='noise.dat')
        print*,' Program creates colored noise with'
        print*,'  PSD   Po / ((alpha^n + f ^ n)) Plus white noise'
        print*,'     plus more power-law noise of P1/f^j'
        print*,'     pluse band-passed filterd noise'
        print*,' '
        print*,' First power law/Gauss-Markov parameters'
        print*,' input the exponent n'
        read(5,*)expon1
        print*,' input term proportional to Po'
        read(5,*)amp1
        print*,' input the time constant alpha in radians/year'
        read(5,*)alpha
        print*,' '
        print*,' Second power law parameters'
        print*,' input the exponent n'
        read(5,*)expon2
        print*,' input term proportional to Po'
        read(5,*)amp2
        print*,' '
        print*,' Input the white noise'
        read(5,*)sig
        print*,' '
        print*,' Creates a second set of noise consisting of ',
     & 'band-passed'
        print*,'  band passed filtered, white noise'
        print*,' Input the lower and upper limits of the filter',
     &' in c/yr'
        read(5,*)fl,fh
        if (fl .gt. fh) then
           f_tem=fl
           fl=fh
           fh=f_tem
        end if
        print*,' Input the number of pole of the filter, 1,2,..'
        read(5,*)np
        print*,' Input the amplitude of the noise'
        read(5,*)f_amp
        fs=1./dt_sam
        if (sig .ne. 0) call white(max_time,sig,ran1,npts,iseed)
        if (amp1 .ne. 0) 
     &   call power_law(max_time,npts,iseed,dt_sam/365.25,
     &     ran2,expon1,amp1,alpha)
        if (amp2 .ne. 0) 
     &   call power_law(max_time,npts,iseed,dt_sam/365.25,
     &     ran3,expon2,amp2,0.0)
        if (f_amp .ne. 0) 
     &   call band_pass(max_time,npts,iseed,dt_sam/365.25,
     &   ran4,fl,fh,np,f_amp)
        rewind(23)
        write(23,*)iseed
        do 58 i=1,ic
          ix=int(t(i)-(t(1))/dt_sam)+1
          d(i)=0.
          if (sig .ne. 0) d(i)=d(i)+ran1(i)
          if (amp1 .ne. 0) d(i)=d(i)+ran2(ix)
          if (amp2 .ne. 0) d(i)=d(i)+ran3(ix)
          if (f_amp .ne. 0) d(i)=d(i)+ran4(ix)
          itime=int(t(i)+t_start)
          dec_time=(t(i)+t_start)-int(t(i)+t_start)
          call inv_jul_time(itime,nyr,jul)
          fjul=float(jul)+dec_time
          write(77,*)nyr,fjul,d(i),t(i)/365.25
58      continue
        print*,' random noise data written to noise.dat'
        close(77)
      end if
c
c save original data and A matrix
c  estimate high frequency standard error in data by taking 1st differences
c

      ic_orig=ic
      sum_diff=0.
      n_diff=0
      do 601 i=1,ic
        d_orig(i)=d(i)
        t_orig(i)=t(i)
        if (i .ne. 1) then
        if (t(i) - t(i-1) .le. dt_sam) then
           sum_diff=sum_diff+(d(i)-d(i-1))**2
           n_diff=n_diff+1
        end if
        end if
        do 602 j=1,nmod
602     A_orig(i,j)=A(i,j)
601   continue
      est_white_noise=sqrt(sum_diff/float(n_diff))/sqrt(2.0)
      print*,' Estimate of white noise component of data is:',
     &  est_white_noise
c
c  decimate the data!
c
      print*,' methods to decimate data'
      print*,' 0 = no decimation'
      print*,' 1 = keep 2, skip 1, keep 2, skip 1'
      print*,' 2 = keep 2, skip 1, keep 1, skip 2, keep 2, skip 1...'
      print*,' 3 = keep 2, skip 1, keep 1, skip 2, keep 1, skip 3,',
     &  ' keep 2 skip 1...'
      print*,' 4 or more...make it option 3'
      print*,'input choice'
      read(5,*)idec

      if (idec .ge. 4) idec=3
      if (idec .ne. 0) then

        call decimate(max_data,max_mod,ic,nmod,A,t,dtime,t_year,d,idec)
        open (77,file='decimate.dat')
        do 59 i=1,ic
          itime=int(t(i)+t_start)
          dec_time=(t(i)+t_start)-int(t(i)+t_start)
          call inv_jul_time(itime,nyr,jul)
          fjul=float(jul)+dec_time
          write(77,*)nyr,fjul,d(i),t(i)/365.25
59      continue
        close(77)
        print*,' Decimated data in decimate.dat'        
      end if
c
c fit data using design matrix and ASSUMPTION of white noise
c
      do 61 i=1,ic
      covar(i,i)=1.0
61    covinv(i,i)=1.0

      call 
     & model_fit(max_data,max_mod,ic,nmod,A,dtime,d,res,
     &  covinv,covar,1,x,e,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
c       print*,(i,x(i),i=1,nmod)

c      call calcres(max_data,max_mod,ic,nmod,A,d,res,covinv,covar,1,x,e)

c      do 62 i=1,nmod
c      print*,x(i),e(i)
c62    continue
      sum_res2=0.0
      det=0.0
      do 63 i=1,ic
63    sum_res2=sum_res2+res(i)**2
      rms=sqrt(sum_res2/float(ic-nmod))
      print*,' RMS fit using white noise model is',
     &  rms
      det=float(ic)*alog(rms)
      f_mle=-det-0.5*sum_res2/(rms**2)
     &   -0.5*float(ic)*alog(2.0*3.14159265)
      print*,' Log MLE for white noise error model is ',f_mle
      print*, ' '
c  output model parameters assuming white noise
      call output(x,e,max_mod,net,nbt,nrate,n_rat_chg,
     & nper,noff,rat_chg1,rat_chg2,off,per,sea,rate_norm,
     &  n_file_press,aux_norm,n_exp,texp,bexp,exp_choice,exp_type,
     &  rat_chng_norm)

      print*,' sampling interval in yrs ',dt_sam/365.25
      print*,' '
      sig1=rms
      print*,'  Input the initial parameters of the PSD and whether',
     &       '   the item is "fix" or "float"'
      print*,'   if "fix", then the item is not estimated'
      print*,'   if "float", then the item is estimated'
      print*,' '
      print*,' Input the white noise "instrument precision" ',
     &          'and fix/float'
      read(5,*)siginstr, choice(1)
      print*,' Input the amplitude first Power law function ',
     &   'and fix/float'
      read(5,*)amp1,choice(2)

      print*,' Input the exponent 1 < n < 3 and fix/float'
      read(5,*)exp1,choice(3)
      print*,' Input the time constant alpha in c/yr and fix/float'
      read(5,*)alpha,choice(4)
      print*,' '
      print*,' Input the parameters for band-passed filtered noise'
      print*,' Input low and high freq stop band in c/yr'
      read(5,*)f1a,f2a
      if (f1a .lt. f2a) then
        flow=f1a
        fhigh=f2a
        else
        flow=f2a
        fhigh=f1a
      end if
      print*,' low frequency stop band is ',flow,' c/yr'
      print*,' high frequency stop band is ',fhigh,' c/yr'
      print*,' number of poles between 1 and 4'
      read(5,*)npole
      print*,' Input the amplitude and fix/float'
      read(5,*)amp_bp,choice(5)
      print*,' Input the exponent of second Power Law function',
     &  ' fix/float'
      read(5,*)exp2,choice(7)
      print*,' Input the amplitude of second PL function fix/float'
      read(5,*)amp2,choice(6)
      print*,' '
      print*,' Sometimes, it may be necessary to add white noise to ',
     &'data so'
      print*, ' that a better estimate of long period PSD parameters ',
     &'can be made.'
      print*,'This is especially true for data that is predominantly ',
     & 'power noise'
      print*,' Enter value of white noise to be added (nominal it ',
     &'should be 0)'
      read(5,*)wh_add
      call gaus(ran1,max_time,iseed)
      do 8889 i=1,ic
      d(i)=d(i)+wh_add*ran1(i)
8889  continue
c
c zero-out covariance
c
      do 69 i=1,ic
      do 691 j=1,i
        covarpl1(i,j)=0.
        covarpl1(j,i)=0.
        covarpl2(i,j)=0.
        covarpl2(j,i)=0.
        covarbp(i,j)=0.
        covarbp(j,i)=0.
691   continue
69    continue

c         print*,' Calculating power law covariance for first set'
c         call pow_law_cov(t_year,ic,0.0,1000.,2.0,0.0,
c     &     covarpl1,max_time,max_data,dt_sam/365.25)

c      do 8888 i=1,ic
c        write(66,*)i,covarpl1(i,i),covarpl1(ic,i),covarpl1(i,ic)
cc        write(67,*)i,(covarpl1(i,j),j=1,ic)
c8888  continue

c
c  If the exponentials are to be "fixed" (choice()), calculate covariance 
c  matrix once and store
c
      ipl_flag_1=0
      if ((choice(3) .eq. 'fix') .and. (choice(4) .eq. 'fix'))  then
         print*,' Calculating power law covariance for first set'
         call pow_law_cov(t_year,ic,0.0,1.0,exp1,alpha,
     &     covarpl1,max_time,max_data,dt_sam/365.25)
         ipl_flag_1=1
      end if

      ipl_flag_2=0
      if ((choice(7) .eq. 'fix'))  then
         print*,' Calculating power law covariance for second set'
         call pow_law_cov(t_year,ic,0.0,1.0,exp2,0.0,
     &     covarpl2,max_time,max_data,dt_sam/365.25)
         ipl_flag_2=1
      end if

      ibp_flag=1

c  call this once and forget about it!
      if (amp_bp .ne. 0) 
     &  call band_pass_cov(t_year,ic,dt_sam/365.25,flow,fhigh,npole,
     &   max_time,max_data,1.0,covarbp)

c
c  figure-out how many loops to run the ameoba routine
c
      iln=0
      do 3999 i=1,7
      if (choice(i) .eq. 'float') iln=iln+1
3999  continue
      if (iln .eq. 1) loop=1
      if (iln .eq. 2) loop=2
      if (iln .gt. 2) loop=iln
c
c  loop through the ameoba routine
c
      print*,' '
      print*,' list of trial covariance parameters'
      write(6,6666)
6666  format('    white noise     PL_1 amp     PL_1 exp      GM freq',
     &'       BP amp',
     &'      PL_2 amp      PL_2 exp  determinant  chi^2       MLE ',
     &'        cpu ')
      do 801 iloop=1,loop


c  Initial guess
      iswt=0
      if (iloop .eq. 1) then
c      print*,' before start funmin'
c      print*,ic,max_data,max_mod,max_time
c      print*,fmle,siginstr,amp1,exp1,alpha,amp_bp,
c     &   npole,flow,fhigh,amp2,exp2,dt_sam/365.25
      call funmin(fmle,siginstr,amp1,exp1,alpha,amp_bp,
     &   npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &   t_year,d,dtime,ic,max_data,max_mod,max_time
     &       ,A,nmod,ipl_flag_1,
     &   ipl_flag_2,ibp_flag,iswt,
     &  covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

c      subroutine funmin(fmle,sig1,sig2,sig3,sig4,sig5,
c     &   npole,flow,fhigh,sig6,sig7,ts_yrs,
c     &   corran,d,txx,jmax,max_data,max_parm,max_time
c     &       ,ax,nmod,ipl_flag_1,
c     & ipl_flag_2,ibp_flag,iswt,
c     & covarpl1,covarpl2,covarbp,
c     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)








       fmax=fmle
       do 802 nx=1,8
       amby(nx)=-fmle
       ambp(nx,1)=siginstr
       ambp(nx,2)=amp1
       ambp(nx,3)=exp1
       ambp(nx,4)=alpha
       ambp(nx,5)=amp_bp
       ambp(nx,6)=amp2
       ambp(nx,7)=exp2
802    continue
       end if

       nx=1
      if (choice(1) .ne. 'fix') then
c  dither the white noise component
c    default dither
        dsig=siginstr*vsig(iloop)
c   compare amplitude of white noise with high frequency of power law noise
c   if power-law high freq is greater than that from white noise; modify dither
        fs=365.25/dt_sam
        psd_db=5.0*exp1*alog10(fs)-7.399*exp1-10*alog10(fs)+2.076
        psd_pl1=(amp1**2)*10.0**(psd_db/10.)
        psd_hf_pl1=psd_pl1/((2.0*fs)**exp1)

        psd_db=5.0*exp2*alog10(fs)-7.399*exp2-10*alog10(fs)+2.076
        psd_pl2=(amp2**2)*10.0**(psd_db/10.)
        psd_hf_pl2=psd_pl2/((2.0*fs)**exp2)
        psd_hf=psd_hf_pl1
        if (psd_hf_pl2 .gt. psd_hf_pl1) psd_hf=psd_hf_pl2
        psd_wh=siginstr**2/(2.0*fs)
        sig_min=sqrt(psd_hf*(2.0*fs))
        if (psd_hf .gt. psd_wh) then
          print*,' Power law noise exceeds that of white noise'
          print*,'  modify white noise from ',siginstr,' to',
     &    sig_min
        end if
        if ((psd_hf .gt. psd_wh) .and. (vsig(iloop) .gt. 1))
     &    dsig=vsig(iloop)*sig_min
        
        if ((psd_hf .gt. psd_wh) .and. (vsig(iloop) .lt. 1))
     &    dsig=sig_min/vsig(iloop)

      call funmin(fmle,dsig,amp1,exp1,alpha,amp_bp,
     &   npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &   t_year,d,dtime,ic,max_data,max_mod,max_time
     &       ,A,nmod,ipl_flag_1,
     &   ipl_flag_2,ibp_flag,iswt,
     &  covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)





         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=dsig
         ambp(nx,2)=amp1
         ambp(nx,3)=exp1
         ambp(nx,4)=alpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=exp2

      end if

      if (choice(2) .ne. 'fix') then
c  dither the power law amplitude
        damp1=amp1*vamp1(iloop)
c  compare with amplitude of band-pass filtered noise at the lowest periods
c    modify dither if PL amplitude is less that BP filtered noise
        if (choice(5) .ne. 'fix') then
          freq=2.0/(t_year(ic)-t_year(1))
c  evalutate  power PL noise
          fs=365.25/dt_sam
          psd_db=5.0*exp1*alog10(fs)-7.399*exp1-10*alog10(fs)+2.076
          psd_pl1=(amp1**2)*10.0**(psd_db/10.)
          psd_pl=psd_pl1/(freq**exp1)
c  evaluate power level of band pass filtered noise
          h=(1.0**2)*((freq/flow)**2)
     &      /((1.0+((freq/flow)**2))*(1.0+((freq/fhigh)**2)))
          if (npole .eq. 2) h=h*h
          if (npole .eq. 3) h=h*h*h
          if (npole .eq. 4) h=h*h*h*h
          if (npole .eq. 5) h=h*h*h*h*h
          if (npole .eq. 6) h=h*h*h*h*h*h
          powBP=h*(amp_bp**2)
          if (powBP .gt. psd_pl) then
            psd_pl=powBP*(freq**exp1)
            amp_mod=psd_pl/(10.**(psd_db/10))
            amp_mod=sqrt(amp_mod)
            if (vamp1(iloop) .gt. 1) damp1=amp_mod*vamp1(iloop)
            if (vamp1(iloop) .lt. 1) damp1=amp_mod/vamp1(iloop)
            print*,'BP Noise at freq=', freq,' exceeds PL noise'
            print*,' PL amp at freq is',psd_pl,' BP amp at freq is',
     &        powBP
            print*,'  Change PL scale from', amp1,' to',amp_mod
          end if
        end if
 
        call funmin(fmle,siginstr,damp1,exp1,alpha,amp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=damp1
         ambp(nx,3)=exp1
         ambp(nx,4)=alpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=exp2

      end if
      if (choice(3) .ne. 'fix') then
c  dither the power law exponent
        dexp1=exp1+vexp1(iloop)

        call funmin(fmle,siginstr,amp1,dexp1,alpha,amp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=amp1
         ambp(nx,3)=dexp1
         ambp(nx,4)=alpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=exp2

      end if
      if (choice(4) .ne. 'fix') then
c  dither the GM freq
        dalpha=alpha*valpha(iloop)
c  if 2*pi/alpha is less than longest period in data, modify
c
        alpha_2pi=2.0*3.14159*alpha
        flong=2.0/(t_year(ic)-t_year(1))
        if (alpha_2pi .lt. flong) then
           if (valpha(iloop) .gt. 1) dalpha=flong*valpha(iloop)
           if (valpha(iloop) .lt. 1) dalpha=flong/valpha(iloop)
        end if
  
        call funmin(fmle,siginstr,amp1,exp1,dalpha,amp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=amp1
         ambp(nx,3)=exp1
         ambp(nx,4)=dalpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=exp2

      end if
      if (choice(5) .ne. 'fix') then
c  dither the Band pass filter amplitude
        damp_bp=amp_bp*vamp_bp(iloop)
c  compare amplitude of BP filtered noise with that from power law noise;
c    change dither if PL noise exceed BP at 0.5*(flow+fhigh)
          freq=0.5*(flow+fhigh)
          fs=365.25/dt_sam
          psd_db=5.0*exp1*alog10(fs)-7.399*exp1-10*alog10(fs)+2.076
          psd_pl1=(amp1**2)*10.0**(psd_db/10.)
          psd_pl1=psd_pl1/(freq**exp1)
          psd_db=5.0*exp2*alog10(fs)-7.399*exp2-10*alog10(fs)+2.076
          psd_pl2=(amp2**2)*10.0**(psd_db/10.)
          psd_pl2=psd_pl2/(freq**exp2)
          psd_pl=psd_pl1
          if (psd_pl2 .gt. psd_pl1) psd_pl=psd_pl2
          
c  evaluate power level of band pass filtered noise
          h=(1.0**2)*((freq/flow)**2)
     &      /((1.0+((freq/flow)**2))*(1.0+((freq/fhigh)**2)))
          if (npole .eq. 2) h=h*h
          if (npole .eq. 3) h=h*h*h
          if (npole .eq. 4) h=h*h*h*h
          if (npole .eq. 5) h=h*h*h*h*h
          if (npole .eq. 6) h=h*h*h*h*h*h
          powBP=h*(amp_bp**2)
          if (psd_pl .gt. powBP) then
            amp_mod=sqrt(psd_pl/h)
            print*,' Modify BP amplitude for dithering'
            print*,' at Freq=',freq
            print*,'   Power law amplitude is ', psd_pl
            print*,'   BP filter amplitude is ', powBP
            print*,'  Change amplitude from',amp_bp,' to', amp_mod
            if (vamp_bp(iloop) .gt. 1) damp_bp=amp_mod*vamp_bp(iloop)
            if (vamp_bp(iloop) .lt. 1) damp_bp=amp_mod/vamp_bp(iloop)
          end if
    
        call funmin(fmle,siginstr,amp1,exp1,alpha,damp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1 ,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=amp1
         ambp(nx,3)=exp1
         ambp(nx,4)=alpha
         ambp(nx,5)=damp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=exp2

      end if
      if (choice(6) .ne. 'fix') then
c  dither the second power law amplitude
        damp2=amp2*vamp2(iloop)

        call funmin(fmle,siginstr,amp1,exp1,alpha,amp_bp,
     &    npole,flow,fhigh,damp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)



         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=amp1
         ambp(nx,3)=exp1
         ambp(nx,4)=alpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=damp2
         ambp(nx,7)=exp2

      end if
      if (choice(7) .ne. 'fix') then
c  dither the second power law exponent
        dexp2=exp2+vexp2(iloop)
 
        call funmin(fmle,siginstr,amp1,exp1,alpha,amp_bp,
     &    npole,flow,fhigh,amp2,dexp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

         nx=nx+1
         amby(nx)=-fmle
         ambp(nx,1)=siginstr
         ambp(nx,2)=amp1
         ambp(nx,3)=exp1
         ambp(nx,4)=alpha
         ambp(nx,5)=amp_bp
         ambp(nx,6)=amp2
         ambp(nx,7)=dexp2

      end if

      print*,' Initial solutions for Amoeba'
      do 4030 i=1,8
4030  print*,amby(i),(ambp(i,j),j=1,7)
      FTOL=0.002
      FTOL=0.005


      call AMOEBA(ambp,amby,8,7,7,FTOL,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &  ITER,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)


c  pick the smallest solution
      small=1.0e+10
      do 769 k=1,8
      if (amby(k) .lt. small) then
        small=amby(k)
        fmax=amby(k)
        siginstr=ambp(k,1)
        amp1=ambp(k,2)
        exp1=ambp(k,3)
        alpha=ambp(k,4)
        amp_bp=ambp(k,5)
        amp2=ambp(k,6)
        exp2=ambp(k,7)
      end if
769   continue
      print*,' '
      print*,' Best fitting solutions'
      print*,' MLE= ',-fmax
      print*,' white noise= ',siginstr
      print*,' Bandpass filter amplitude= ',amp_bp
      print*,' power law noise 1'
      print*,'    amplitude= ',amp1
      print*,'    exponent= ',exp1
      print*,'    G-M freq= ',alpha
      print*,' power law noise 2'
      print*,'    amplitude= ',amp2
      print*,'    exponent= ',exp2
      print*,' '


      do 770 k=1,8
       amby(k)=fmax
       ambp(k,1)=siginstr
       ambp(k,2)=amp1
       ambp(k,3)=exp1
       ambp(k,4)=alpha
       ambp(k,5)=amp_bp
       ambp(k,6)=amp2
       ambp(k,7)=exp2
770    continue



801   continue



c
c estimate errors and covariance of spectral parameters
c
      dith(1)=0.01
      dith(2)=0.01
      dith(3)=0.05
      dith(4)=0.05
      dith(5)=0.05
      dith(6)=0.05
      dith(7)=0.1
      x(1)=siginstr
      x(2)=amp1
      x(3)=exp1
      x(4)=alpha
      x(5)=amp_bp
      x(6)=amp2
      x(7)=exp2

3913  continue
c rerun best fit solution but estimate standard error on model parameters
      iswt=0

c       call funmin(fmle,siginstr,amp1,exp1,alpha,amp_bp,
c     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
c     &     t_year,d,dtime,ic,max_data,max_mod,max_time
c     &         ,A,nmod,ipl_flag_1,
c     &     ipl_flag_2,ibp_flag,iswt,
c     &     covarpl1,covarpl2,covarbp,
c     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
c      iswt=1
 
        call funmin(fmle,siginstr,amp1,exp1,alpha,amp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

      print*,' Start the covariance calculations for noise model'
      do 3911 i=1,7
        print*,' best estimate',x(i),'  dither',dith(i)
3911  continue
c
c  do diagonal terms
c
      nchoice=0
      do 3915 i=1,7
        ierr=0
        if (choice (i) .eq. 'float') then
        nchoice=nchoice+1
3912    continue
        do 3914 k=1,7
3914    xx(k)=x(k)
          xx(i)=x(i)-dith(i)*x(i)
c  comment-out if xx(i) <0
c          if (xx(i) .lt. 0) then
c            xx(i)=0.
c            dith(i)=1.0
c          end if
c
          if (ierr .eq. 10 ) go to 39155
c  set max number of loops to get dither! Sometimes, I don't get convergence
c

        call funmin(fv2,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

          if (fv2+fmax .gt. 10.0*FTOL) then
c          if (fv2+fmax .gt. 5.0*FTOL) then
c          if (fv2+fmax .gt. 2.0*FTOL) then
             fmax=-fv2
             print*,' Found better, optimal model'
             if (i .eq. 1) siginstr=xx(i)
             if (i .eq. 2) amp1=xx(i)
             if (i .eq. 3) exp1=xx(i)
             if (i .eq. 4) alpha=xx(i)
             if (i .eq. 5) amp_bp=xx(i)
             if (i .eq. 6) amp2=xx(i)
             if (i .eq. 7) exp2=xx(i)
             x(i)=xx(i)
             go to 3913
c   jump out of do loop since we found a better model!
          end if
c   Modify dither
          if (( abs(fv2 + fmax) .lt. FTOL) .and.
     &      (dith(i) .lt. 0.01)) then
             dith(i)=1.9*dith(i) 
             print*,' Dither changed to ', dith(i)
             go to 3912
          end if
          if ((abs(fv2 + fmax) .gt. 5.0*FTOL) .and.
     &     (dith(i) .gt. 0.001)) then
            dith(i)=0.6*dith(i)
             print*,' Dither changed to ', dith(i)
            go to 3912
          end if

         
39155     continue

          xx(i)=x(i)+dith(i)*x(i)

        call funmin(fv1,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
c          if (fv1+fmax .gt. 2.0*FTOL) then
          if (fv1+fmax .gt. 5.0*FTOL) then
             fmax=-fv1
             print*,' Found better, optimal model'
             if (i .eq. 1) siginstr=xx(i)
             if (i .eq. 2) amp1=xx(i)
             if (i .eq. 3) exp1=xx(i)
             if (i .eq. 4) alpha=xx(i)
             if (i .eq. 5) amp_bp=xx(i)
             if (i .eq. 6) amp2=xx(i)
             if (i .eq. 7) exp2=xx(i)
             x(i)=xx(i)
             go to 3913
c   jump out of do loop since we found a better model!
          end if
c          if (iflag .eq. 1) i=5
c          if (iflag .eq. 1) go to 3913
           acov(nchoice,nchoice)=
     &     abs( (fv1+fv2+2*fmax)/( (dith(i)*x(i))**2 ) )
c          print*,nchoice,nchoice,fv1,fv2,-fmax,dith(i)*x(i),
c     &     acov(nchoice,nchoice)
c          print*,(fv1+fv2+2*fmax),( (dith(i)*x(i))**2 )
      end if
3915  continue
c
c  the off-diagonal terms
c
      ii=0
      do 3920 i=1,7
      if (choice (i) .eq. 'float') then
      ii=ii+1
      jj=0
      do 3919 j=1,i
      if (choice (j) .eq. 'float') then
        jj=jj+1
        do 3902 k=1,5
3902    xx(k)=x(k)
        if (i .ne. j)  then
c     
c  i not equal to j....got do 4 of these calculations rather than 2!
          xx(i)=x(i)+dith(i)*x(i)
          xx(j)=x(j)+dith(j)*x(j)

        call funmin(fv1,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

          xx(i)=x(i)+dith(i)*x(i)
          xx(j)=x(j)-dith(j)*x(j)
 
        call funmin(fv2,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

          xx(i)=x(i)-dith(i)*x(i)
          xx(j)=x(j)+dith(j)*x(j)

        call funmin(fv3,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

          xx(i)=x(i)-dith(i)*x(i)
          xx(j)=x(j)-dith(j)*x(j)

        call funmin(fv4,xx(1),xx(2),xx(3),xx(4),xx(5),
     &    npole,flow,fhigh,xx(6),xx(7),dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
          acov(ii,jj)=abs(fv1+fv4-fv2-fv3)/
     &        (4.*dith(i)*x(i)*dith(j)*x(j))
          acov(jj,ii)=acov(ii,jj)
c          print*,ii,jj,
c     &     fv1,fv2,fv3,fv4,dith(i)*x(i),dith(j)*x(j),acov(i,j)
        end if
      end if
3919  continue
      end if
3920  continue
c   take inverse of acov
      print*,' '
      print*,' Inverse covariance matrix'
      do 3930 i=1,7
      print*,i, 'acov= ',(acov(i,j),j=1,7)
3930  continue
c  invert acov  to get covariance matrix
      call ssyev('V','L',nchoice,acov,8,dith,wz,23,ier)
      print*,' The eigenvalues ',(dith(i),i=1,nchoice)
      print*,' ier=', ier
      do 3931 i=1,nchoice
      do 3932 j=1,nchoice
      at=0.
        do 3933 k=nchoice,1,-1
        at=at+acov(i,k)*acov(j,k)/dith(k)
3933    continue
      cov(i,j)=at
3932  continue
3931  continue
      print*,' '
      print*,' the covariance matrix'
      nzz=0
      ii=0      
      do 3935 i=1,7
      if (choice(i) .eq. 'float') then
        ii=ii+1
        nzz=nzz+1
        dith(i)=sqrt(abs(acov(ii,ii)))
        jj=0
        do 3934 j=1,i
        if (choice(j) .eq. 'float') then
          jj=jj+1
          acov(ii,jj)=cov(ii,jj)/sqrt(cov(ii,ii)*cov(jj,jj))
          acov(jj,ii)=acov(ii,jj)
          else
          acov(i,j)=0.
        end if
3934    continue
      else
        dith(i)=0.0
      end if
      print*,i,' cov= ',(cov(i,j),j=1,7)
3935  continue
      print*,' '
      print*,' Cross correlation matrix'
      do 3940 i=1,5
      print*,i,' cross correlation ',(acov(i,j),j=1,7)
3940  continue      
c
c print-out optimal LS fit parameters
c
c  search 'max.out' for MLE
      print*,fmax
      rewind (12)
      rewind (13)
      irow=1
      fmin=9999.e+30
      fmax=-fmax
7245  continue
        read(12,7112,end=7246)fxx
7112    format(91x,2x,10x,13x,f13.3)
        dif=abs(fxx-fmax)
        if (dif .le. fmin) isave=irow
        if (dif .le. fmin) fmin=dif
        irow=irow+1

        go to 7245
7246  continue
      print*,' '
      print*,' '

      print*,' row number for optimal solution is',isave
      do 7247 i=1,isave
      read(13,*)(x(j),e(j),j=1,nmod)
7247  continue 
      read(13,*)(x(j),e(j),j=1,nmod)
      print*,' nmod=',nmod
c      write(6,72488)filename(1:20),(x(j),e(j),j=1,nmod)
      print*,(x(j),e(j),j=1,nmod)
72488  format(a20,3x,120(1x,f10.3,' +/- ',f10.3))
c  use best MLE and recalculate the model
        iswt=1
c  calculate error bars on model  (x and e) e being the error
        call funmin(fv4,siginstr,amp1,exp1,alpha,amp_bp,
     &    npole,flow,fhigh,amp2,exp2,dt_sam/365.25,
     &     t_year,d,dtime,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,iswt,
     &     covarpl1,covarpl2,covarbp,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

       rewind (13)
c  count rows
       irow=0
8430   continue
         read(13,*,end=8431)
         irow=irow+1
         go to 8430
8431   continue
       print*,' number of rows is', irow
       rewind (13)
       do 8432 i=1,irow-1
8432   read (13,*)
      ix=0
      do 8433 i=1,n_exp
8433  if (exp_choice(i) .eq. "float") ix=ix+2
c      read(13,*)(x(j),e(j),j=1,nmod),(x(j+nmod),e(j+nmod),j=1,ix)
      read(13,*)(x(j),e(j),j=1,nmod),(x(j+nmod),enull,j=1,ix)
c      write(6,7248)filename(1:20),(x(j),e(j),j=1,nmod),
c     &  (x(j+nmod),e(j+nmod),j=1,ix)
      print*,(x(j),e(j),j=1,nmod),
     &  (x(j+nmod),enull,j=1,ix)



c  modify rates due to normalization
      if (nrate .ne. 0) then
        x(nbt+1)=x(nbt+1)/rate_norm
        e(nbt+1)=e(nbt+1)/rate_norm
      end if
      if (n_rat_chg .ne. 0) then
        do 72481 kkk=1,n_rat_chg
        x(nbt+nrate+kkk)=x(nbt+nrate+kkk)/rat_chng_norm(kkk)
        e(nbt+nrate+kkk)=e(nbt+nrate+kkk)/rat_chng_norm(kkk)
72481   continue
      end if
      if (n_file_press .ne. 0) then
         nc=nbt+nrate+n_rat_chg+nper*2+noff+nexp_fit

         do 72483 kkk=1,n_file_press
         x(nc+kkk)=x(nc+kkk)/aux_norm(kkk)
         e(nc+kkk)=e(nc+kkk)/aux_norm(kkk)
72483    continue
      end if

      write(14,7248)filename(1:20),(x(j),e(j),j=1,nmod),
     &  (x(j+nmod),e(j+nmod),j=1,ix)

7248  format(a20,3x,120(1x,f10.3,' +/- ',f10.3))
c  undo normalization
      if (nrate .ne. 0) then
        x(nbt+1)=x(nbt+1)*rate_norm
        e(nbt+1)=e(nbt+1)*rate_norm
      end if
      if (n_rat_chg .ne. 0) then
        do 72482 kkk=1,n_rat_chg
        x(nbt+nrate+kkk)=x(nbt+nrate+kkk)*rat_chng_norm(kkk)
        e(nbt+nrate+kkk)=e(nbt+nrate+kkk)*rat_chng_norm(kkk)
72482   continue
      end if
      if (n_file_press .ne. 0) then
         nc=nbt+nrate+n_rat_chg+nper*2+noff+nexp_fit

         do 72484 kkk=1,n_file_press
         x(nc+kkk)=x(nc+kkk)*aux_norm(kkk)
         e(nc+kkk)=e(nc+kkk)*aux_norm(kkk)
72484    continue
      end if


c
c  use optimal model to compute data residuals
c
      nmod_orig=nmod
      call modify_A(A,max_data,max_mod,ic,nmod,dtime,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start)
c      print*,' Update A matrix'

c      print*,nmod,nmod_orig,(x(i),i=1,nmod)
c      print*,1,(A(1,i),i=1,nmod)
c      print*,ic,(A(ic,i),i=1,nmod)
      open (65,file='resid_dec.out')
      do 9001 i=1,ic
        calc_m=0.
        do 9002 j=1,nmod
        calc_m=calc_m+A(i,j)*x(j)
9002    continue
      res_m=d(i)-calc_m
      itime=int(t(i)+t_start)
      dec_time=(t(i)+t_start)-int(t(i)+t_start)
      call inv_jul_time(itime,nyr,jul)
      fjul=float(jul)+dec_time
      write(65,6501)float(nyr),fjul,res_m,calc_m,d(i)
9001  continue
      close (65)
      print*,' Residual, decimated data in resid_dec.out'
      print*,' col 1 & 2, time; 3 is residual,',
     &  '4 is calculated, 5 is data'
c same for undecimated data
      nmod=nmod_orig
      call modify_A(A_orig,max_data,max_mod,ic_orig,nmod,dtime_orig,
     &  n_exp,bexp,texp,exp_choice,exp_type,t_start)
c      print*,' Update A_orig matrix'

c      print*,nmod,nmod_orig,(x(i),i=1,nmod)
c      print*,1,(A_orig(1,i),i=1,nmod)
c      print*,ic,(A_orig(ic,i),i=1,nmod)

      open (65,file='resid.out')
      do 9011 i=1,ic_orig
        calc_m=0.
        do 9012 j=1,nmod
        calc_m=calc_m+A_orig(i,j)*x(j)
9012    continue
      res_m=d_orig(i)-calc_m
      itime=int(dtime_orig(i)+t_start)
      dec_timed=(dtime_orig(i)+t_start)-int(dtime_orig(i)+t_start)
      call inv_jul_time(itime,nyr,jul)
c      fjul=float(jul)+dec_time
c      write(65,*)float(nyr),fjul,res_m,calc_m,d_orig(i)
      write(65,6501)float(nyr),float(jul)+dec_timed,
     &   res_m,calc_m,d_orig(i)
6501  format(1x,f6.0,1x, f15.9, 3(1x,f15.2))

9011  continue
      close (65)
      print*,' Residual, data in resid.out'
      print*,' col 1 & 2, time; 3 is residual,',
     &  '4 is calculated, 5 is data'
c  output model parameters using best noise model
      print*,' '
      print*,' '

      call output(x,e,max_mod,net,nbt,nrate,n_rat_chg,
     & nper,noff,rat_chg1,rat_chg2,off,per,sea,rate_norm,
     &  n_file_press,aux_norm,n_exp,texp,bexp,exp_choice,exp_type,
     & rat_chng_norm)
      print*,' '
      print*,' '
      nc=0
      do 9015 i=1,7
        e(i)=0.
        if (choice(i) .eq. 'float') then
           nc=nc+1
           e(i)=sqrt(abs(cov(nc,nc)))
        end if
9015  continue

      print*,' Best fitting solutions'
      print*,' MLE= ',fmax
      print*,' white noise= ',siginstr,' +/-',e(1)
      print*,' Bandpass filter amplitude= ',amp_bp,
     &    ' +/-',e(5)
      print*,' power law noise 1'
      print*,'    amplitude= ',amp1,' +/-',e(2)
      print*,'    exponent= ',exp1,' +/-',e(3)
      print*,'    G-M freq= ',alpha,' +/-',e(4)
      print*,' power law noise 2'
      print*,'    amplitude= ',amp2,' +/-',e(6)
      print*,'    exponent= ',exp2,' +/-',e(7)
      print*,' '
      write(15,7879)filename(1:20),fmax,idec,ic,nmod,
     &  siginstr,e(1),
     &  amp1,e(2),    
     &  exp1, e(3),    
     &  alpha, e(4),    
     &  amp_bp, e(5),    
     &  amp2, e(6),    
     &  exp2, e(7),sea
7879  format(a20,3x,f10.3,3i6,7(3x,f10.3,1x,f10.3),3x,f10.3)    
      close(23)
      close(12)
      close(13)
      close(14)
      close(15)

      stop
      end
c2345678901234567890123456789012345678901234567890123456789012345678901234567890
      subroutine funmin(fmle,sig1,sig2,sig3,sig4,sig5,
     &   npole,flow,fhigh,sig6,sig7,ts_yrs,
     &   corran,d,txx,jmax,max_data,max_parm,max_time
     &       ,ax,nmod,ipl_flag_1,
     & ipl_flag_2,ibp_flag,iswt,
     & covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
c
c  computes maximum likelihood for specified inputs
c
c  fmle Log maximum likelihod
c  sig1  white-noise
c  sig2  random walk noise
c  sig3  exponent of PSD
c  sig4  time-constant of PSD
c  sig5 is amplitude of Band-pass filtered noise
c    npole is the number of poles for BP filter
c    flow and fhigh is the pass-band in c/yr for BP filter
c  sig6  amplitude of second power law noise
c  sig7  exponent of second power law
c  ts_yrs  sampling interval in years
c  corran  time in years of data (double precision
c  d   data is sequential order
c  jmax  number of observations
c  max_data and max_parm  dimensions of matrices
c  ax   design matrix
c  nmod  number of parameters in design matrix
c  ipl_flag_1  a flag; if 1, power law covariance matrix has been computed for
c  iswt  switch for yes/no calc of error bars for model
c
c  dimension statements that work with ifc but not with g77
c      dimension d(max_data),x(max_parm),xe(max_parm),
c     & covar(max_data,max_data),ccovar(max_data,max_data),
c     & res(max_data)
c      dimension dr(max_data),ax(max_data,max_parm)
c      double precision dsum,corran(max_data)
c      double precision dett
c      dimension covarpl1(max_data,max_data),covarbp(max_data,max_data),
c     &  covarpl2(max_data,max_data)
     
c dimension statements that work with g77; should work with all fortran
      dimension d(max_data),x(max_parm),xe(max_parm),
     & covar(8103,8103),ccovar(8103,8103),
     & res(8103)
      dimension dr(8103),ax(max_data,max_parm)
      double precision dsum,corran(max_data)
      double precision dett
      dimension covarpl1(max_data,max_data),covarbp(max_data,max_data),
     &  covarpl2(max_data,max_data)
c      common covarpl1,covarbp,covarpl2
      double precision texp(10),t_start,txx(max_data),t_stop
      dimension bexp(10), parm(10)
      character*7 exp_choice(10), exp_type(10)
      md=max_data
      maxnmod=max_parm
      mmax=max_time

c      print*,' start funmin'
c       print*,jmax,max_data,max_parm,max_time
c       print*,fmle,sig1,sig2,sig3,sig4,sig5,
c     &   npole,flow,fhigh,sig6,sig7,ts_yrs

c      print*,'funmin',sig1,sig2,sig3,sig4,sig5,sig6,sig7
      iswitch_verbose=0

c   if iswitch_verbose=1----lots of output

3890  continue
      if (jmax .gt. md) then
       print*, 'Number of observations, ',jmax,' greater than',
     &         ' storage ',md
       stop
      end if
      if (nmod .gt. maxnmod) then
       print*, 'Number of model param., ',nmod,' greater than',
     &   ' storage ',maxnmod
       stop
      end if
      small=1.0e-10
c  make sure that everything is positive except  but exponent to power law
      sig1=abs(sig1)
      sig2=abs(sig2)
      sig4=abs(sig4)
      sig5=abs(sig5)
      sig6=abs(sig6)
c  
c
c  figure-out the equivalent PSD parameters....the Po term!
c
      fs=1./ts_yrs
      t_small=ts_yrs
      if (sig2 .ne. 0 ) then
        pow_db=5*sig3*alog10(fs)-7.339*sig3-10*alog10(fs)+2.076
        pow_db=20*alog10(sig2)+pow_db
        Po=10**(psd_db/10.)
      end if

c
c  compute ratio to relate Po to the random walk number
c
c
c  figure-out lowest value of sig1 detectable
c
c  compute smallest sampling interval

      fny=1/(2*t_small)
      sig1_orig=sig1
      fs=1./ts_yrs
      sig_min=sig2*sqrt(2.0)*((2./3.14159)**(sig3/2.))/(fs**(sig3/4))

c      print*," sig1=", sig1, " sig_min=", sig_min
c      if (sig1 .lt. sig_min/2.) sig1=sig_min/2.0
c      print*, " sig1=", sig1


      if (sig4 .lt. 0) then
        print*,' '
        print*,' Time constant was ',sig4
        sig4=0.0001
        sig4=2.0*3.14159/(60*corran(jmax))
        print*,' force time constant to be ',sig4
      end if
c      if (sig4 .gt. 6.28/corran(jmax))
c     &     sig4=6.28/corran(jmax)
      sig4_orig=sig4
      

      siginstr=sig1**2
c test for negative amplitude for band-pass filter noise
      if (sig5 .lt. 0) then
         print*,' force BP-filter coef > 0 ',sig5
         sig5=0.01
      end if

      if ( iswitch_verbose .eq. 1 ) then
      print*,' '
      print*,' Initial parameters'
      print*,'  white noise ',sqrt(siginstr),' mm'

      print*,'  random walk ',sig2,' units/yr^0.25*sig3'
      print*,'  exponent to PDS ', sig3
      print*,'  cut-off freq for 1-GM ', sig4
      print*,' The amplitude of PSD at 1 c/yr in db is: ',pow_db

      if (sig4 .ne. 0) then
        fo=sig4/(2*3.14159265)
        print*,' low frequency break point is: ',fo,' c/yr'
        print*,' amplitdue of PSD at lowest frequency (DC) in db is ',
     &  psd_db -10*sig3*alog10(fo)
      end if
      if (sig1 .ne. 0) then
c        print*,fny,sig1
        print*,' amplitude of PSD at highest frequency is db is: ',
     &  10*alog10(sig1*sig1/fny)
        fc=(((Po)*fny)/(sig1*sig1))**(1./sig3)
        print*,' cross over freq (c/yr) ',fc
      end if
      print*,' BP-filter amplitude: ',sig5
      print*,' BP-filter parameters; Poles= ',npole,
     & ' low and high freqs; ',flow,fhigh,' c/yr'
      if (sig6 .ne. 6) then
        print*,' Amplidude of second power law noise ',sig6,
     &   ' units/yr^0.25*sig7'
        print*,' Exponent of second power law noise', sig7
      end if

      end if

       time0=secnds(0.0)
        
c      max=ifix(corran(jmax)*365.25)
c  zero-out covariance
c      do 6995 i=1,jmax
c      do 6994 j=1,i
c      covar(i,j)=0.
c      ccovar(i,j)=0.
c      ccovar(j,i)=0.
c      covar(j,i)=0.
c      covarbp(i,j)=0.
c      covarbp(j,i)=0.
6994  continue
6995  continue
c     XXXX
c      do 6666 i=1,jmax
c6666  write(77,*)i,corran(i)
c      if (jmax .gt. 1 ) stop

      if (ipl_flag_1 .ne. 1)  then
         
         call pow_law_cov(corran,jmax,sig1,sig2,sig3,sig4,
     &    covar,mmax,md,t_small)
         

      end if
      if (ipl_flag_2 .ne. 1) 
     &  call pow_law_cov(corran,jmax,0.0,1.0,sig7,0.0,
     &  covarpl2,mmax,md,t_small)

c
c construct covariance do to BP-filtered noise
c
       if (ibp_flag .ne. 1) then
       if (sig5 .ne. 0) 
     &  call band_pass_cov(corran,jmax,t_small,flow,fhigh,npole,
     &   mmax,md,1.0,covarbp)
       end if

c add covariance
c       if ((sig2 .ne. 0) .and. (sig5 .eq. 0) .and. (sig6 .eq. 0) then
c       do 7010 i=1,jmax
c       do 7009 j=1,i-1
c       covar(i,j)=(sig2**2)*covarpl1(i,j)
c7009   continue
c       covar(i,i)= (sig2**2)*covarpl1(i,j)+sig1**2
c7010   continue
c       end if

       if (iswitch_verbose .eq. 1) then
       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' start adding covariances', del_sec
       end if
       if ((ipl_flag_1 .eq. 1) .and. (sig2 .ne. 0)) then
       do 7000 i=1,jmax
       do 7001 j=1,i-1
       covar(i,j)=(sig2**2)*covarpl1(i,j)
7001   continue
       covar(i,i)=(sig2**2)*covarpl1(i,i)+sig1**2
7000   continue
       end if
       if (sig5 .ne. 0) then
       do 7002 i=1,jmax
       do 7003 j=1,i
       covar(i,j)=(sig5**2)*covarbp(i,j)+covar(i,j)
7003   continue
7002   continue
       end if

       if (sig6 .ne. 0) then
       do 7004 i=1,jmax
       do 7005 j=1,i
       covar(i,j)=(sig6**2)*covarpl2(i,j)+covar(i,j)
7005   continue
7004   continue
       end if
c       do 8000 i=1,jmax
c8000   write(89,8001)i,(covar(i,j),j=1,jmax)
c8001   format(i5,100f12.5)
       covar_max=0.
       covar_min=1.0e+20
       covar_minx=1.0e+20
       do 7006 i=1,jmax
       do 7007 j=1,i-1
       if (abs(covar(i,j)) .gt. covar_max) then
          covar_max=covar(i,j)
          i_max=i
          j_max=j
       end if
       if (abs(covar(i,j)) .lt. covar_min) then
          covar_min=covar(i,j)
          i_min=i
          j_min=j
       end if 
       if (  (abs(covar(i,j)) .lt. covar_minx ) .and.
     &       (abs(covar(i,j)) .ne. 0.0 ) ) then
          covar_minx=covar(i,j)
          i_minx=i
          j_minx=j
       end if   
       covar(j,i)=covar(i,j)
       ccovar(i,j)=covar(i,j)
       ccovar(j,i)=covar(i,j)
7007   continue
       ccovar(i,i)=covar(i,i)
7006   continue
       if (iswitch_verbose .eq. 1) then
         print*,' max covar = ',covar_max,' at element',i_max,j_max
         print*,' min covar = ',covar_min,' at element',i_min,j_min
         print*,' min covar0 = ',covar_minx,' at element',i_minx,j_minx
       end if
      c_large=1.0e+30
      jswitch=1
      if (jswitch .eq. 0) then
c
c  install a fix here
c    when GM (sig4) is large >6, the covariance matrix has small, off diagonal
c     terms.  Both spotrf and spotri cann't deal with values of zero; although
c     an inverse is computed, it take much cpu time to compute. Thus, the fix
c     is to change elements that are really small to something that is small.
       if (sig4 .ne. 0.0) then
       if (covar_max/covar_minx .gt. c_large) then
         covmin=1.0/c_large
         n0=0
         do 70061 i=1,jmax
         do 70062 j=1,i
c            if (covar(i,j) .ne. 0.0) then
            if (abs(covar(i,j)) .lt. covmin) then
              covar(i,j)=covmin
              covar(j,i)=covmin
              ccovar(i,j)=covmin
              ccovar(j,i)=covmin
              n0=n0+1
c            end if
            end if
70062    continue
70061    continue
           if (iswitch_verbose .eq. 1)then 
             print*,' Number of elements replace by 0 is',n0
             timex=secnds(0.0)
             del_sec=timex-time0
             print*,' Zeroed-out covariance', del_sec
           end if
         end if
         end if

      end if

       

c
c  do cholsky
c

       del_sec=timex-time0

       if (iswitch_verbose .eq. 1) then

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' start spotrf', del_sec
       end if

       call spotrf('L',jmax,ccovar,md,nerror)
c       do 6003 i=1,5
c6003   print*,(ccovar(i,j),j=1,5)
c       do 6004 i=jmax-5,jmax
c6004   print*,(ccovar(i,j),j=jmax-5,jmax)
c       print*,(i,ccovar(i,i),i=1,jmax)

       if (iswitch_verbose .eq. 1) then

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' finish spotrf', del_sec
       end if
       
c  bail-out if nerror not equal 0
      if (nerror .ne. 0) then
      print*,' covariance is singular'
      sig2_new=sig2*0.78
      print*,' replace amplitude of noise,', sig2,' by ',sig2_new
      sig2=sig2_new
      if (sig4 .ne. sig4_orig) sig4=sig4_orig
      if (sig1 .ne. sig1_orig) sig1=sig1_orig
      go to 3890
      end if
      
c  copy lower triangular part of ccovar
c  calc the determanant
c  search for stuff close to zero

      dett=0.0
      covar_max=0.
      covar_min=1.0e+20
      covar_minx=1.0e+20
      do 730 i=1,jmax
        dsum=ccovar(i,i)
        dett=dett+dlog(dsum)
c        do 7329 k=1,jmax
c7329   covinv(i,k)=ccovar(i,k)
        do 7328 j=1,i
        if (abs(ccovar(i,j)) .gt. covar_max) then
          covar_max=ccovar(i,j)
          i_max=i
          j_max=j
        end if
        if (abs(ccovar(i,j)) .lt. covar_min) then
          covar_min=ccovar(i,j)
          i_min=i
          j_min=j
        end if 
        if (  (abs(ccovar(i,j)) .lt. covar_minx ) .and.
     &       (abs(ccovar(i,j)) .ne. 0.0 ) ) then
          covar_minx=ccovar(i,j)
          i_minx=i
          j_minx=j
       end if 
7328   continue  
730   continue
      if (iswitch_verbose .eq. 1) then
        print*, 'Natural log of determinant ', dett
         print*,' max covar = ',covar_max,' at element',i_max,j_max
         print*,' min covar = ',covar_min,' at element',i_min,j_min
         print*,' min covar0 = ',covar_minx,' at element',i_minx,j_minx
 
         timex=secnds(0.0)
         del_sec=timex-time0
         print*,' start spotri',del_sec
      end if
c      c_large=1.0e+30
       if (covar_max/covar_minx .gt. c_large) then
         covmin=covar_max/c_large
         n0=0
         do 70063 i=1,jmax
         do 70064 j=1,i
c            if (ccovar(i,j) .ne. 0.0) then
            if (abs(ccovar(i,j)) .lt. covmin) then
              ccovar(i,j)=covmin

              n0=n0+1
c            end if
            end if
70064    continue
70063    continue
           if (iswitch_verbose .eq. 1) then
             print*,' Number of elements replace by 0 is',n0
             timex=secnds(0.0)
             del_sec=timex-time0
             print*,' Zeroed-out covariance', del_sec
           end if
         end if
c
c invert cholesky matrix
c

       call spotri('L',jmax,ccovar,md,nerror)

       if (nerror .ne. 0) then
          print*, ' finished spotri but result is singular'
          print*,'   nerror=',nerrror
          stop
       end if
       if (iswitch_verbose .eq. 1) then

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' finish spotri', del_sec
       end if
c  fill in upper trianguangular part of matrix
c
      do 7325 i=1,jmax
      do 7324 j=i+1,jmax
      ccovar(i,j)=ccovar(j,i)
7324  continue
7325  continue
       if (iswitch_verbose .eq. 1) then

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' finish inversion', del_sec
       end if

c  
c      iswww=1
c      open(29,file="junk_1fd.dat")
c      do 706 ii=1,jmax
c      write(112,*)d(ii)
c706   write(29,1111)(ccovar(ii,jj),jj=1,jmax),res(ii)
c1111  format(1800f9.4,/)
c      close (29)
c      if (iswww .eq. 1) stop 
c      
c
c  check for inverse
c
      icheck=0
      if (icheck .eq. 1) then
      print*,' starting check'
      suminv=0.
      do 77110 i=1,jmax
c      write(77,777)i,(ccovar(i,j),j=1,jmax)
      do 77111 j=1,jmax
      dsum=0.
        do 77112 k=1,jmax
        dsum=dsum+covar(i,k)*ccovar(k,j)
77112    continue
      if (i .eq. j) suminv=suminv+(1.-dsum)**2
      if (i .ne. j) suminv=suminv+dsum**2
77111  continue
77110  continue
      print*,'inverse check',suminv
      end if
c  
c  
c  fit model using updated covariance matrix and compute residuals    
c      call calcres(max_data,max_parm,jmax,nmod,
c     &  ax,d,dr,ccovar,covar,iswt,x,xe) 
c      print*," start model_fit"
c      print*,(k,bexp(k),texp(k),exp_choice(k),exp_type(k),k=1,nexp),
c     & ' t_start and t_stop', t_start, t_stop
      call model_fit(max_data,max_parm,jmax,nmod,ax,txx,d,dr,
     &  ccovar,covar,iswt,x,xe,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

  
c
c multiply inv(chol(ccovar))*d and square the cumulative 
c
c  need to do transpose!
      sumres=0.
      do 7320 i=1,jmax
      res(i)=0.
        do 7321 j=1,jmax
        res(i)=res(i)+dr(i)*ccovar(i,j)*dr(j)
7321    continue
c      print*,i,res(i)
      sumres=sumres+res(i)
7320  continue
      if (iswitch_verbose .eq. 1) 
     &  print*,' Z^t * C^{-1} * Z =', sumres
c
c  compute maximum likelyhood estimate
c
c  dett is half the true determainant determinant is
      fmle=(-1.0*dett-0.5*sumres)
     &      -0.5*float(jmax)*alog(2.0*3.14159265)
c      print*,' ln of max likelihood=', fmle
       timex=secnds(0.0)
       del_sec=timex-time0

      if (sig4 .ne. sig4_orig) sig4=sig4_orig
      if (sig1 .ne. sig1_orig) sig1=sig1_orig
      if (sumres .gt. 999999999. ) sumres=999999999.
      if (fmle .lt. -9999999.) fmle=-9999999.
      write(6,7491)sig1,sig2,sig3,sig4,sig5,sig6,sig7,dett,
     &   sumres,fmle,del_sec
      write(12,7490)sig1,sig2,sig3,sig4,sig5,sig6,sig7,dett,
     & sumres,fmle
7490  format(7f13.4,2x,e10.3,2f13.3)
7491  format(7f13.4,2x,e10.3,3f13.3)
c  print out the time constants if 'float'
      if (nexp .ne. 0) write(6,7493)(bexp(k),k=1,nexp)
7493  format( 10(' tau= ',e10.2, '  '))



       if( iswithc_verbose .eq. 1) 
     &  print*,' finish MLE', del_sec
c      print*,sig4_orig,sig1_orig
      if (sig4 .ne. sig4_orig) sig4=sig4_orig
      if (sig1 .ne. sig1_orig) sig1=sig1_orig
c      print*,sig4_orig,sig1_orig
      return
      end

      subroutine band_pass_cov(corran,jmax,t_small,flow,fhigh,npole,
     &   mmax,md,sig5,covar)

       dimension cr(mmax),covar(md,md)
       double precision corran(md)
       len=int((corran(jmax)-corran(1))*365.25+0.5)
c       print*,' BP filt called',jmax,t_small,flow,fhigh,
c     &  npole,corran(jmax),sig5,mmax,md
      time0=secnds(0.0)
      do 1 i=1,jmax
        do 2 j=1,i
        covar(i,j)=0.
        covar(j,i)=0.
2       continue
1     continue

       call band_pass_filt(t_small,flow,fhigh,npole,mmax,len,cr,sig5)
       print*,' BP filt 2',jmax,t_small,flow,fhigh,
     &  npole,corran(jmax),sig5,mmax,md

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' form Band Pass filter', del_sec


       do 9056 i=1,jmax
       imax=int((corran(i)-corran(1))/t_small+0.5)+1
       sumlast=0.
       do 9055 k=1,i
         dsum=0.0
         kmax=int((corran(k)-corran(1))/t_small+0.5)+1
         do 9054  kk=1,kmax

         dsum=dsum+cr(imax+1-kk)*cr(kmax+1-kk)
9054     continue
         sumlast=dsum
         covar(i,k)=dsum
9055   continue
9056   continue
c       print*,' Covariance for BP-filtered noise constructed'

       timex=secnds(0.0)
       del_sec=timex-time0
       print*,' form Band Pass filter Covariance', del_sec

      return
      end
      subroutine band_pass(nmax,npts,iseed,ts,ran,fl,fh,np,amp)
c
c  creates band_passed filtered noise by convolving white noise
c   with a filter with pass bands between fl and fh and
c   np being the number of poles
c
c  nmax is the dimension of data array (input)
c  npts  is number of points (input)
c  iseed is the seed for random number generator (input/output)
c  ts  is sampling interval in year (input)
c  ran is the noise data (output)
c  fl is frequency of low part of pass band c/yr (input)
c  fh is frequency of high part of pass band c/yr (input
c  np is the number of poles, 1,2,3 or 4 (input)
c  amp is the amplitude
      dimension ran(nmax),ran1(nmax)
      dimension H(nmax)
      call gaus(ran1,nmax,iseed)
      iseed=int(ran1(nmax-1)*100000)
      if (iseed .eq. 0) iseed=int(ran(nmax-1)*10000000) 
      amp_orig=amp
      print*,' IN BANDPASS', amp,ts,npts,fl,fh,np
      call band_pass_filt(ts,fl,fh,np,nmax,npts+100,H,amp)
c
c  convolve with data
c
      do 52 i=1,npts+100
        ran(i)=0.0
        do 53 j=1,i
        ran(i)=ran(i)+ran1(j)*H(i-j+1)
53      continue
52    continue
c  shift over random numbers
      do 60 i=1,npts
        ran(i)=ran(i+100)
c        write(90,*)ran(i)
60    continue
      amp=amp_orig
      return
      end
      subroutine band_pass_filt(ts,fl,fh,np,nmax,npts,H,amp)
c create a bandpass filter in the time domain
c  define filter in frequency domain then take inverse fft of filter
c    tranfer function to get time domain impulse responce
c  ts is sampling interval in years
c  fl and fh are low and high freq break pts in c/yr
c  np is number of poles 1 to 4
c  nmax is the dimension
c  npts is the number of points in time series
c  H on output is the impulse responce
c  amp is the amplitude of filter.
      dimension H(nmax)
      complex hc(nmax),h1,h2,h3,h4
      fh=fh*ts
      fl=fl*ts
      fn=0.5
c  fix bug;
      H(1)=1.
      H(1)=0.
      len=npts+100
      nf=int(len/2)
      nf=int((log(float(len/2))/log(2.))+0)
      nf=nf+1
      nf=2**nf
c      print*,' Number of frequencies ',nf
      len=2*nf
c      print*,' length of time series for band-pass noise is ',len
c      print*,ts,fl,fh,np,amp
      peak=-99999.
      do 50 i=1,nf
        f=(1/float(len))*(i)
        h1=cmplx(1.0,0.0)
        h2=cmplx(0.,f/fl)
        h3=cmplx(1.0,f/fl)
        h4=cmplx(1.,f/fh)
        hc(i)=h1*h2/(h3*h4)
        if (np .eq. 2) hc(i)=hc(i)*hc(i)
        if (np .eq. 3) hc(i)=hc(i)*hc(i)*hc(i)
        if (np .eq. 4) hc(i)=hc(i)*hc(i)*hc(i)*hc(i)
        if (np .eq. 5) hc(i)=hc(i)*hc(i)*hc(i)*hc(i)*hc(i)
        if (np .eq. 6) hc(i)=hc(i)*hc(i)*hc(i)*hc(i)*hc(i)*hc(i)
        H(i*2+1)=real(hc(i))
        H(i*2+2)=-aimag(hc(i))
        if (cabs(hc(i)) .gt. peak) then
           peak=cabs(hc(i))
           f_peak=f/ts
        end if
c      write(70,100)f/ts,real(hc(i)),-aimag(hc(i)),
c     & 20*alog10(cabs(hc(i))),
c     &   57.2958*atan2(real(hc(i)),-aimag(hc(i))),i*2+1,i*2+2
100   format(5f15.5,2i6)
50    continue
c      peak=peak
      H(2)=cabs(hc(nf))

c      write(70,100)float(1/(ts*2)),H(2),0,20*alog10(H(2))
c      print*,' peak gain is ',20*log10(peak),' db  at ',f_peak,' c/yr'
      fo=0.5*(fl+fh)
      calc_amp=(fo/fl)/(sqrt(1.0 + (fo/fl)**2)*sqrt(1.0 + (fo/fh)**2))
      calc_amp=(calc_amp**np)
c      print*,' Calculated peak gain ',20*log10(calc_amp), 
c     &  ' at ',fo/ts,' c/yr'
c      amp=amp/peak
cc      print*,' Normalized to ',20*log10(amp)+20*log10(peak), ' db'
cc      print*,' Factor in amplitude; gain is: ',
cc     &  20*log10(amp*peak), ' db'
cc      print*,' Final peak amplitude ',20*log10(amp) ,' db'
cc
cc  compute inverse transform
cc
      call realft(H,len,-1)
      do 51 i=1,len
c        write(80,*)amp*H(i)*2.0/float(len)
        H(i)=((amp/peak)*H(i)*2.0/float(len))*sqrt(0.5/ts)
51     continue
c       print*,' Amplitude of BP-noise: ',20*log10(amp/calc_amp),
c     &    ' db at ',365.25*fo,' c/yr'
      fh=fh/ts
      fl=fl/ts
c      amp=amp*peak

       return
       end

      subroutine pow_law_cov(corran,jmax,sig1,sig2,sig3,sig4,covar,
     & mmax,md,t_small)
c  Power Law covariance
      dimension covar(md,md), irow(md)
      double precision dcr(mmax), dsum,corran(md),sumlast
     &  ,dmax,dmin,dmin0,dcmax,dcmin,dsmall,dtemp
      do 1 i=1,jmax
        do 2 j=1,i
        covar(i,j)=0.
        covar(j,i)=0.
2       continue
1     continue

c       xt_small=999999e+30
c       do 888 i=2,jmax
c       if (corran(i)-corran(i-1) .lt. xt_small)
c     &       xt_small=corran(i)-corran(i-1)
c888    continue
c       print*,t_small,xt_small


c   power law covariance
c assumes corran(1) .eq. 0
c  colored noise for exponent
c
c USE FRACTIONAL DIFFERENCE
c       print*,'  jmax=', jmax,' corran(jmax)= ',corran(jmax)-corran(1)
       kmax=int((corran(jmax)-corran(1))/t_small + 0.5)+1
       if (kmax .gt. mmax) then
         print*,' kmax = ',kmax,' exceeds mmax of ',mmax
         stop
       end if
       time0=secnds(0.0)
       call  frac_diff(dcr,sig3,sig4,t_small,kmax,mmax)

c  Bug fix;  noted that standard error of nominal value was incorrect for
c    kswitch0=0; okay for kswitch0=1;  Problem rooted in that first row (or column)
c    of covariance matrix was not all zeros.

      kswitch0=1
c      kswitch0=0
       if ( kswitch0 .ne. 0 ) then
       do 881 i=mmax,2,-1
       dcr(i)=dcr(i-1)
881    continue
       dcr(1)=0
       end if
c       write(89,*)(sngl(dcr(i)),i=1,jmax)
c       print*,' cr=',(cr(ik),ik=1,10),cr(kmax)
c       timex=secnds(0.0)
c       del_sec=timex-time0
c       print*,'test form Fract Diff', del_sec
  
       const=(sig2**2)*(t_small**(sig3/2.0))
c       print*,'const= ',const
c
c  scan through dcr look for terms close to zero
c    and force to zero
c

c       dsmall=1.0d-30

c       do 7002 i=1,kmax
c       if (dabs(dcr(i)) .lt. dsmall) dcr(i)=0.0

c7002   continue






c  Original


      if ( kswitch0 .eq. 0) then

C original

       do 7006 i=1,jmax
       imax=int((corran(i)-corran(1))/t_small+0.5)+1

       sumlast=0.
       do 7005 k=1,i
         dsum=0.0
         kmax=int((corran(k)-corran(1))/t_small+0.5)+1


         do 7004  kk=1,kmax


         dsum=dsum+dcr(imax+1-kk)*dcr(kmax+1-kk)
7004     continue


         covar(i,k)=sngl(dsum)*const
         if (i .eq. k) covar(i,k)=covar(i,k)+sig1**2
7005   continue
cc       write(89,8001)i,(covar(i,k),k=1,i-1),covar(i,i),
cc     &   (covar(i,k),k=i+1,jmax)
cc8001   format(i5,100f12.5)
7006   continue

       else 
c  Modified
       imak=0
       if ( imak .eq. 0) then
         do 70061 i=2,jmax
         imax=int((corran(i)-corran(1))/t_small+0.5)+1

c       if (i .eq. jmax) print*,'jmax and imax= ',jmax,imax
         sumlast=0.
         do 70051 k=2,i
           dsum=0.0
           kmax=int((corran(k)-corran(1))/t_small+0.5)+1

c         print*,k,kmax
           do 70041  kk=1,kmax


           dsum=dsum+dcr(imax+1-kk)*dcr(kmax+1-kk)
70041       continue

c
c         if (dsum .lt. sumlast) then
c           print*,' problem in covariance matrix'
c           print*,i,k,dsum,sumlast,imax,kmax
c           stop
c         end if
c         sumlast=dsum

           covar(i,k)=sngl(dsum)*const
           if (i .eq. k) covar(i,k)=covar(i,k)+sig1**2
70051     continue

70061     continue
        covar(1,1)=sig1**2
c  modification May 2006
c        covar(1,1)=covar(1,1)+const
        end if
        if (imak .eq. 1) then

          do 2011i=1,jmax
            ix=int((corran(i)-corran(1))/t_small+0.5)+1

            irow(i)=ix
2011      continue
         imax=int((corran(jmax)-corran(1))/t_small+0.5)+1
c         print*,'imax=',imax,' jmax=',jmax,' mmax=',mmax
         call makeMatrix(irow,imax,sngl(dcr),covar,jmax,0,mmax)

         do 2801 i=1,jmax
           do 2802 j=1,i
           covar(i,j)=covar(i,j)*const
           if (i .eq. j) covar(i,j)=covar(i,j)+sig1**2
           covar(j,i)=covar(i,j)
c           ccovar(i,j)=covar(i,j)
c           ccovar(j,i)=covar(i,j)
2802       continue
2801     continue

        end if

      end if

c       do 8000 i=1,jmax
c       write(89,8001)i,(covar(k,i),k=1,i-1),covar(i,i),
c     &   (covar(k,i),k=i+1,jmax)
c8001   format(i5,100f12.5)
c8000   continue
 

c       timex=secnds(0.0)
c       del_sec=timex-time0
c       print*,'test Power law formed covariance', del_sec
c      do 200 i=1,10
c200    print*,i,corran(i),(covar(i,k),k=1,10)

      return
      end

      subroutine calcres(max_data,max_parm,ic,nmod,
     &  ax,d,dr,covinv,covar,iswitch,x,e)
c max_data  dimension of data
c max_parm  dimension of num parameters
c ic number of data
c nmod number of parameters
c ax  design matrix
c d  data
c dr  residuals
c covinv  inverse covariance matrix
c covar  covariance matrix
c iswitch  outputs the model and its error if set to 1
c  x  the model
c  e  the error
c
      dimension a1(max_parm,max_data),a2(max_parm,max_parm),
     &  ai(max_parm,max_parm),ainv(max_parm,max_data)
      dimension ax(max_data,max_parm),x(max_parm),
     &  covinv(max_data,max_data),
     &  d(max_data),dr(max_data)
      dimension ev(max_parm),wz(500),covar(max_data,max_data)
      dimension e(max_parm)
      dimension xcovar(82,82)
      double precision ad2(max_parm,max_parm),wzd(5000),evd(max_parm)
      mdmax=max_data
      maxnmod=max_parm
c      print*,'calcres  mdmax=',mdmax,' maxnmod=',maxnmod,
c     &  ' ic=',ic,' nmod=',nmod
c      do 99 i=1,10
c99    print*,i,d(i),(ax(i,j),j=1,nmod)
c      do 98 i=ic-10,ic
c98    print*,i,d(i),(ax(i,j),j=1,nmod)

     
c-------------------------------------------------------------
c
c  find new model that fits data using updated covariance matrix
c
c
c  compute At*covinv
c
      call sgemm('T','N',nmod,ic,ic,1.0,ax,mdmax,covinv,mdmax,
     & 0.0,a1,maxnmod)
c
c compute At*covinv*A   A1*A
c
      call  sgemm('N','N',nmod,nmod,ic,1.0,a1,maxnmod,ax,mdmax,
     & 0.0,a2,maxnmod)
      do 20 i=1,nmod
      do 19 j=1,nmod
19    ad2(i,j)=a2(i,j)
20    continue
c
c invert At*covinv*A
c
c      call ssyev('V','L',nmod,a2,maxnmod,ev,wz,500,ier)
      call dsyev('V','L',nmod,ad2,maxnmod,evd,wzd,5000,ier)
      if (iswitch .eq. 1) print*,' Eigenvalues ',(i,evd(i),i=1,nmod)

c      do 209 i=1,nmod
c      ev(i)=abs(ev(i))
c209   continue

c examine the eigenvalues
      ie=1
      iflag=0
      do 210 i=nmod-1,1,-1
        if (iflag .eq. 1) go to 210
        rat=evd(i)/evd(nmod)
        rat=abs(rat)
        if (rat .lt. 1.0e-09) go to 211
        ie=ie+1
        go to 210
211     iflag =1
210   continue
       if (iswitch .eq. 1)
     &   print*,' Using ',ie,' out of', nmod,' eigenvalues'
c  construct inverse
     
      if (ier .ne. 0) then

        print*,' eigenvalues ',(evd(i),i=1,nmod)
        print*,' ier= ',ier
        print*,'  if ier=0; success'
        print*,'        <0the i-th argument had an illegal value'
        print*,'        >0the algorithm  failed  to  converge'
        print*,'      do a man ssyev'
      end if
      do 220 i=1,nmod
      do 221 j=1,nmod
        at=0.0
        do 222 k=nmod,nmod-ie+1,-1
222     at=at+ad2(i,k)*ad2(j,k)/evd(k)
221   ai(i,j)=at
220   continue
c
c compute the inverse matrx 
c
      call sgemm('N','N',nmod,ic,nmod,1.0,ai,maxnmod,a1,maxnmod,
     & 0.0,ainv,maxnmod)
c
c  compute the model
c
      do 230 i=1,nmod
      x(i)=0.
      e(i)=0.
         do 231 j=1,ic
231      x(i)=x(i)+ainv(i,j)*d(j)
c test
c         x(i)=0.

230   continue
c
c compute the residuals
c
      do 235 i=1,ic
      dr(i)=0.
        do 236 j=1,nmod
236     dr(i)=dr(i)+ax(i,j)*x(j)
      dr(i)=d(i)-dr(i)
235   continue
c
c compute the error bars
c
c  switch to compute model cross correlation or not (icorr=1 -- compute
      icorr=1

      do 329 i=1,nmod
329   continue
      if ((iswitch .eq. 1) .and. (icorr .eq. 1)) then
      do 330 i=1,nmod
      do 3301 ii=1,nmod
      xcovar(i,ii)=0.0
c      e(i)=0.
      xsum=0.0
        do 331 k=1,ic
        do 332 j=1,ic
c        e(i)=e(i)+ainv(i,k)*covar(k,j)*ainv(i,j)
        xsum=xsum+ainv(i,k)*covar(k,j)*ainv(ii,j)
332     continue
331     continue
c      print*,i,e(i)
c      e(i)=sqrt(e(i))
      xcovar(i,ii)=xsum
3301  continue
      e(i)=sqrt(xcovar(i,i))
330   continue
c  compute cross correlation
      open(35,file="cross_cor.out")
      write(35,4403)(ii,ii=1,nmod)
4403  format(//,15x,89i6)
      do 4401 i=1,nmod
        write(35,4402)i,e(i),( (xcovar(i,ii)/(e(i)*e(ii))),ii=1,nmod)
4401  continue
4402  format(i5,e10.2,82f6.2)
      end if

c      write(13,130)(x(i),e(i),i=1,nmod)
c130   format(30(3x,f15.3,1x,f15.3))
c--------------------------------------------------------------- 
      return
      end
      subroutine decimate(max_data,max_parm,ic,nmod,a,t,dtime,
     &   t_year,d,idec)
c idec=1 uses 67% of data
c idec=2 uses 50% of data
c idec=3 uses 40% of data
      dimension a(max_data,max_parm),t(max_data),d(max_data)
      dimension ax(max_data,max_parm),ttemp(max_data),dtemp(max_data)
      double precision t_year(max_data),tyrtemp(max_data),
     &  dtime(max_data),dtimetmp(max_data),t
      icdec=1
c      print*,idec,d(2),t(2),t_year(2)
      if (idec .eq. 1) then
         do 6501 i=4,ic-4,3
         dtemp(icdec)=d(i-3)
         ttemp(icdec)=t(i-3)
         dtimetmp(icdec)=dtime(i-3)
         tyrtemp(icdec)=t_year(i-3)
           do 6511 j=1,nmod
           ax(icdec,j)=a(i-3,j)
6511       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-2)
         ttemp(icdec)=t(i-2)
         dtimetmp(icdec)=dtime(i-2)
         tyrtemp(icdec)=t_year(i-2)
           do 6521 j=1,nmod
           ax(icdec,j)=a(i-2,j)
6521       continue
         icdec=icdec+1
6501     continue
      end if
      if (idec .eq. 2) then
         do 6502 i=7,ic-7,6
         dtemp(icdec)=d(i-6)
         ttemp(icdec)=t(i-6)
         dtimetmp(icdec)=dtime(i-6)
         tyrtemp(icdec)=t_year(i-6)
           do 6512 j=1,nmod
           ax(icdec,j)=a(i-6,j)
6512       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-5)
         ttemp(icdec)=t(i-5)
         dtimetmp(icdec)=dtime(i-5)
         tyrtemp(icdec)=t_year(i-5)
           do 6522 j=1,nmod
           ax(icdec,j)=a(i-5,j)
6522       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-3)
         ttemp(icdec)=t(i-3)
         dtimetmp(icdec)=dtime(i-3)
         tyrtemp(icdec)=t_year(i-3)
           do 6532 j=1,nmod
           ax(icdec,j)=a(i-3,j)
6532       continue
         icdec=icdec+1
6502     continue
      end if
      if (idec .eq. 3) then
         do 6503 i=11,ic-11,10
         dtemp(icdec)=d(i-10)
         ttemp(icdec)=t(i-10)
         dtimetmp(icdec)=dtime(i-10)
         tyrtemp(icdec)=t_year(i-10)
           do 6513 j=1,nmod
           ax(icdec,j)=a(i-10,j)
6513       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-9)
         ttemp(icdec)=t(i-9)
         dtimetmp(icdec)=dtime(i-9)
         tyrtemp(icdec)=t_year(i-9)
           do 6523 j=1,nmod
           ax(icdec,j)=a(i-9,j)
6523       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-7)
         ttemp(icdec)=t(i-7)
         dtimetmp(icdec)=dtime(i-7)
         tyrtemp(icdec)=t_year(i-7)
           do 6533 j=1,nmod
           ax(icdec,j)=a(i-7,j)
6533       continue
         icdec=icdec+1
         dtemp(icdec)=d(i-4)
         ttemp(icdec)=t(i-4)
         dtimetmp(icdec)=dtime(i-4)
         tyrtemp(icdec)=t_year(i-4)
           do 6543 j=1,nmod
           ax(icdec,j)=a(i-4,j)
6543       continue
         icdec=icdec+1
6503     continue
      end if
         
      if (idec .ne. 0) then
      print*,' Using ',icdec-1,' out of ',ic,' values'
      ic=icdec-1
      do 6599 i=1,ic
      d(i)=dtemp(i)
      t(i)=ttemp(i)
      dtime(i)=dtimetmp(i)
      t_year(i)=tyrtemp(i)
        do 6598 j=1,nmod
6598    a(i,j)=ax(i,j)
6599  continue
      end if
      return
      end
      subroutine frac_diff(crr,expon,alpha,ts,npts,nmax)
c use Hosking routine to create fractional differences
c  crr are the fractional difference
c  expon is the exponent
c  alpha is the GM freq in radians/yr
c  ts is the sampling interval in years
c  npts is length of time series
c  nmax is dimension of crr
      double precision crr(nmax),small
      small=1.0d-10
      ddexp=0.5*expon
         do 39 j=1,npts+100
         if (j .eq. 1) fracti=1.0
         if (j .eq. 2) then
            fracti=ddexp
            fracti_last=fracti
         end if
         if (j .ge. 3) then
            fracti=fracti_last*(ddexp+float(j-2))/float(j-1)
            fracti_last=fracti
         end if
c         crr(j)=fracti*((1.0-alpha*ts)**((j)))
c  above isn't right; for alpha large, 1-alpha*ts goes to 0
c         crr(j)=fracti*((1.0-alpha*ts)**((j-1)))
c    above isn't correct when alpha*ts > 1.0
         crr(j)=fracti*dexp(-dble(alpha)*ts*float(j-1))
         if (crr(j) .lt. small) crr(j)=small
c         write(89,*)j,ts,alpha, (1.0-alpha*ts),j-1
c         write(89,*) (1.0-alpha*ts)**((j-1)),fracti,crr(j)
     
39       continue
      return
      end
      subroutine power_law(nmax,npts,iseed,ts,ran,expon,amp,alpha)
c  creates power law noise (and Gaus Markov)
c
c  nmax is the dimension of data array (input)
c  npts  is number of points (input)
c  iseed is the seed for random number generator (input/output)
c  ts  is sampling interval in year (input)
c  ran is the noise data (output)
c  expon  is the exponent of power law noise
c  amp is the amplitude of power law noise
c  alpha is the GM time constant in radians/years
c
      dimension ran(nmax),ran1(nmax)
      double precision crr(nmax)
      call gaus(ran1,nmax,iseed)
      iseed=int(ran1(nmax-1)*100000)
      if (iseed .eq. 0) iseed=int(ran(nmax-1)*10000000) 
c  use fractional differences to create noise
      call frac_diff(crr,expon,alpha,ts,npts+100,nmax)
c convolve fractional differences with white noise
         do 44 i=1,npts+100
         sum=0.
           do 440 j=1,i
           sum=sum+crr(j)*ran1(1+i-j)
440        continue
         ran(i)=amp*sum* ((ts)**(expon/4) )
44       continue
c  shift data over by 100 points to remove 1st set of numbers
        do 1 i=1,npts
1       ran(i)=ran(i+100)
      return
      end 
      subroutine white(nmax,sigma,ran,npts,iseed)
c  creates a set of white noise with 
c  nmax is the dimension of data array (input)
c  sig  is the standard deviation of white noise (input)
c  ran  is the white noise time series (output)
c  npts  is length of time series number of points (input)
c  iseed is the seed for random number generator (input/output)
      dimension ran(nmax)
      call gaus(ran,nmax,iseed)
      iseed=int(ran(nmax-1)*100000)
      if (iseed .eq. 0) iseed=int(ran(nmax-1)*10000000) 
      do 1 i=1,npts
1     ran(i)=ran(i)*sigma
      do 2 i=npts,nmax
2     ran(i)=0
      return
      end
      subroutine gaus(x,nd,ir)
c  program creates white noise with a gausian distribution with
c  variance=1 and mean equal to zero
c  x are an array of random numbers
c  nd is the length of the array
c  ir is the seed for the random number generator
      dimension x(1)
      if (ir .gt. 0) ir=-1*ir
      do 1 i=1,nd
      x(i)=gasdev(ir)
1     continue
      return
      end
      FUNCTION GASDEV(IDUM)
c From Numerical Recipes; 1992
      SAVE ISET,GSET
      DATA ISET/0/
      IF (ISET.EQ.0) THEN
1       V1=2.*RAN1(IDUM)-1.
        V2=2.*RAN1(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1. .or. r .eq. 0)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
      RETURN
      END
      FUNCTION RAN1(IDUM)
c From Numerical Recipes; 1992
c idum must be less than zero to initialize
      integer idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     &   NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-07,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum .le. 0 .or. iy .eq. 0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum .lt. 0) idum=idum+IM
          if (j .le. NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum .lt. 0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      end
      subroutine redundent(max_time,max_data,max_mod,d,t,dtime,
     &   A,dt_sam,
     &   ic,nmod)

c examine measurements times and if there are redundent measurements
c   within period of less than the minimum sampling interval, average
c   those measurements
c  diminsions  max_time, max_data, max_mod
c   d  data
c   t  time  dtime  is same but double precison
c   A design matrix
c   dt_sam  sampling interval in days
c   ic  and nmod  number of data and model parameters
c
      dimension A(max_data,max_mod), d(max_data),t(max_data)
      dimension AP(max_time,max_mod), dp(max_time),tp(max_time)
      double precision  dtime(max_data),dtp(max_data),t
      integer icnt(max_time)
      do 5 i=1,max_time
      icnt(i)=0.
      dp(i)=0.
      dtp(i)=0.0
      tp(i)=0.
         do 4 j=1,nmod
4        AP(i,j)=0.
5     continue
      do 10 i=1,ic
        ix=int((t(i)-int(t(1)))/dt_sam)+1
        icnt(ix)=icnt(ix)+1
        dp(ix)=dp(ix)+d(i)
        tp(ix)=tp(ix)+t(i)
        dtp(ix)=dtp(ix)+dtime(i)
        do 9 j=1,nmod
9       AP(ix,j)=AP(ix,j)+A(i,j)
10    continue
      if (ix .gt. max_time) then
        print*,' subrouting redundent stops'
        print*,'  dimensions exceeded, ix=',ix,' >',max_time
        stop
      end if
      ic=0
      do 11 i=1,ix
        if (icnt(i) .ge. 1) then
          ic=ic+1
          t(ic)=tp(i)/float(icnt(i))
          dtime(ic)=dtp(i)/float(icnt(i))
          d(ic)=dp(i)/float(icnt(i))
          do 12 j=1,nmod
12        A(ic,j)=AP(i,j)/float(icnt(i))
        end if
11    continue

      return
      end


      

      subroutine date2day(yr,mon,date,day)
      integer yr,date,day,mon
      dimension mnth(12)
      data (mnth(i),i=1,12)/0,31,59,90,120,151,181,212,243,273,304,334/
c
      yr=yr-1900

      day=0
      day=int(yr-60)*365
      if (yr .le. 60) go to 3
      day= day+1
      if (yr .le. 64) go to 3
      day= day+1
      if (yr .le. 68) go to 3
      day= day+1
      if (yr .le. 72) go to 3
      day= day+1
      if (yr .le. 76) go to 3
      day= day+1
      if (yr .le. 80) go to 3
      day= day+1
      if (yr .le. 84) go to 3
      day=day+1
      if (yr .le. 88) go to 3
      day=day+1
      if (yr .le. 92) go to 3
      day=day+1
      if (yr .le. 96) go to 3
      day=day+1
      if (yr .le. 100) go to 3
      day=day+1     
      if (yr .le. 104) go to 3
      day=day+1     
      if (yr .le. 108) go to 3
      day=day+1     
      if (yr .le. 112) go to 3
      day=day+1     
      if (yr .le. 116) go to 3
      day=day+1     
3     day=day+mnth(mon)+date
      if (((yr .eq. 80) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     &  (yr .eq. 72) .or. (yr .eq. 76) .or. (yr .eq. 80) .or. 
     & (yr .eq. 84) .or.(yr .eq. 88)
     &  .or. (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100)
     & .or. (yr .eq. 104) .or. (yr .eq. 108) .or. (yr .eq. 112)
     & .or. (yr .eq. 116))
     1  .and. (mon .ge. 3)) go to 10
      go to 11
10    day= day+1
      
11    continue
      yr=yr+1900
      return
      end

       subroutine invcal(day,yr1,mn,date)
c
c inverse calender function
c
c  give day number relative to jan 1, 1980
c  output dat yr, month and day
c
       integer day,yr,mn,date,yr1
       integer year(60),month(22),lmnth(22)
c       data (year(i),i=1,20)/0,366,731,1096,1462,1827,2192,2557,2923,
c     1  3288,3653,4018,4384,4749,5114,5479,5845,6210,6575,6940/
       data (month(i),i=1,13)/0,31,59,90,120,151,181,212,243,273,304,
     1                           334,365/
       data (lmnth(i),i=1,13)/0,31,60,91,121,152,182,213,244,274,305,
     1                          335,366/
       icnt=-365
       do 40 j=1,60
         jj=j+2
         xx=float(jj)/4 - (ifix(jj/4.))
         if (xx .ne. 0) add=365
         if (xx .eq. 0) add=366
c         ixx=ifix(jj/4.) - int(jj/4)
c         if (ixx .ne. 0) add=365
c         if (ixx .eq. 0) add=366
         icnt=icnt+add
         year(j)=icnt
40     continue

c select the year
       yr=0
1      continue
       if (day .lt. year(yr+1)) go to 5
       yr=yr+1
       go to 1
5      continue
       yr=yr-1
       id=day-year(yr+1)
       yr=yr+60
       yr1=yr+1900
c  leap year sense
       if ((yr .eq. 80) .or. (yr .eq. 84) .or. (yr .eq. 88) .or.
     & (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100) .or.
     & (yr .eq. 104) .or. (yr .eq. 108) .or. (yr .eq. 112) .or.
     &   (yr .eq. 116) .or.
     & (yr .eq. 60) .or. (yr .eq. 64) .or. (yr .eq. 88) .or.
     & (yr .eq. 72) .or. (yr .eq. 76)) go to 20
c  select the month
       mn=1
7      continue
       if (id .le. month(mn)) go to 10
       mn=mn+1
       go to 7
10     mn=mn-1
       date=id-month(mn)
       return
c  select month for the leap year
20     continue
       mn=1
27     continue
       if (id .le. lmnth(mn)) go to 30
       mn=mn+1
       go to 27
30     mn=mn-1
       date=id-lmnth(mn)
       return
       end


      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1
      if (yr .gt. 112 ) iday=iday+1
      if (yr .gt. 116 ) iday=iday+1

      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
      subroutine inv_jul_time(itime,nyr,jul)
c converts day number since jan 1, 1960 back to julian day and year
c
c  itime is number of days since Jan 1, 1960
      dimension nyear(60),nleap(60)
      nx=60
        do 1 i=1,nx
        nleap(i)=1+(i-1)*4
1       continue
        j=1
        ncnt=0
        do 2 i=1,nx
        if (i .eq. nleap(j)) then
           ncnt=ncnt+366
           j=j+1
        else
          ncnt=ncnt+365
        end if
        nyear(i)=ncnt
c        print*,i,nyear(i)
2       continue
      k=1
      nyr=1960
c      if (itime .lt. nyear(1)) then
      if (itime .le. nyear(1)) then
        jul=itime
        return
      end if
      k=2
      nyr=nyr+1
3     continue
      if ((itime .gt. nyear(k-1)) .and. (itime .le. nyear(k))) then
        jul=itime-nyear(k-1)
        return
      else
        k=k+1
        nyr=nyr+1
        go to 3
      end if
      end
      subroutine instradj_read(numinst,instname,instnum,instart,instop,
     & insol,intot,infunc,inparam)
c  READS INSTRUMENT CONSTANTS
c  program makes adjustment of distance due to different instruments
c  distances are adjusted to those of instrument 21
c used in following programs
c    ~/gorda/monitort1.f
c   ~/mammoth/model/monitort1.f
c  ~/proglib/segrat.f
c  ~/proglib/condistpd2.f
c  ~/test.dir/caliby1.f
c  ~/test.dir/caliby2.f
c ~/test.dir/slac/test.f
c ~/test.dir/conplot1.f
c ~/pearblossom/sample.f
c ~/pearblossom/est_noise_3b.f
c
c  numinst   number of instruments
c  instname  instrument name  21a
c  instnum   instrument number 21
c  instart   start date for instrument 910102
c  instop    end date for instrument 930101
c  insol     number of free parameter to fit using calibration data 
c  intot     total number of parameters needed for instrument constants
c  infunc    function number describing the calibration curve
c  inparam   the intot parameters for the calibration curve
c
c     dest--baseline distance in km
c     num---instrument number
c     offset-computed offset in mm base upon num and dest
c
      character*3,instname(30)
      integer instnum(30),insol(30),intot(30),infunc(30)
      integer instart(30),instop(30)
      real inparam(30,10)
c      open(1,file="/home/langbein/proglib/sublib/instradj.dat")
c   for onyx
c      open(1,file="/vhz/langbein/noise/instradj.dat")


      i=1
1     continue
      read(1,100,end=10)instname(i),instnum(i),instart(i),instop(i),
     & insol(i),intot(i),infunc(i)
c      print*,i,infunc(i)
100   format(a3,i3,2i8,3i2)
      read(1,*)(inparam(i,j),j=1,intot(i))
      i=i+1
      go to 1
10    continue
      numinst=i-1
      close (1)
      return
      end

      subroutine instr_adj(dest,iinst,offset,iyr,mn,iday,
     & numinst,instname,instnum,instart,instop,
     & insol,intot,infunc,inparam)
      double precision dest
      character*3,instname(30)
      integer instnum(30),insol(30),intot(30),infunc(30)
      integer instart(30),instop(30), date
      real inparam(30,10), param(10)
      mdim=10
      dd=dest
      k=1
      date=iyr*10000 + mn*100 + iday
c      print*,date,iinst,dd
1     continue
c          print*,date,instart(k),instop(k),k,instnum(k)
c   match instrument number
      if (iinst .eq. instnum(k)) then
c    match date
        if ((date .ge. instart(k)) .and. (date .lt. instop(k))) then
c          print*,k,instnum(k),infunc(k),(inparam(k,j),j=1,intot(k))
          do 2 kk=1,intot(k)
2         param(kk)=inparam(k,kk)
          offset=-1.0*fun(infunc(k),dd,param,mdim)
          return
         end if
       end if
       k=k+1
       if (k .le. numinst) go to 1
       print*,' no match in instrument #',iinst,iyr,mn,iday
      stop
      end
c
c -------------------------------------------------------------
c
      function fun(nfu,y,a,mdim)
      dimension a(mdim)
c      print*,'a=',(a(k),k=1,mdim)
      if (nfu .ne. 1 ) go to 10
      fun=a(1)
      return
c__________________________

10    if (nfu .ne. 2) go to 20

      fun=a(1)
      if (y .gt. a(3)) go to 1
      fun=fun-a(2)
      return
1     continue
      fun=fun+a(2)
      return
c____________________________
c
c -------------------------------------------------------------
c
20    if (nfu .ne. 3) go to 30
      fun=a(1)+a(2)*sin(6.283185*y/a(4))+a(3)*cos(6.283185*y/a(4))
      return
c
30    continue
      if (nfu .ne. 4) go to 40
c  a linear model
      fun=a(1)+a(2)*(y-5.0)
      return
40    continue
c______________
c  linear plus a step
      if (nfu .ne. 5) go to 50
      fun=a(1)+a(2)*(y-5.0)
      if ( y .gt. a(4)) go to 45
      fun= fun - a(3)
      return
45    continue
      fun=fun+ a(3)
      return
50    continue
c ____________
c linear plus a sinusoid
      if (nfu .ne. 6) go to 60
      fun=a(1)+a(2)*(y-5.0)+a(3)*sin(6.283185*y/a(5))+
     1                a(4)*cos(6.283185*y/a(5))
      return
c
c three offset points
60    continue
      if (nfu .ne. 7) go to 70
        if (y .lt. a(5)) then
        fun=a(1)
        return
        end if
        if ((y .ge. a(5)) .and. (y .lt. a(6))) then
        fun=a(2)
        return
        end if
        if ((y .ge. a(6)) .and. (y .lt. a(7))) then
        fun=a(3)
        return
        end if
        fun=a(4)
        return
c
c linear plus 3-offsets
70    if (nfu .ne. 8) go to 80
        if (y .lt. a(6)) then
        fun=a(1)+a(5)*(y)
        return
        end if
        if ((y .ge. a(6)) .and. (y .lt. a(7))) then
        fun=a(2)+a(5)*(y)
        return
        end if
        if ((y .ge. a(7)) .and. (y .lt. a(8))) then
        fun=a(3)+a(5)*(y)
        return
        end if
        fun=a(4)+a(5)*(y)
        return
80    continue
c ____________
c linear plus 3 sinusoid
      if (nfu .ne. 9) go to 90
      f1=2.0*3.1415926*y/(2.*a(9))
      f2=f1*2.0
      f3=f1*3.0
      fun=a(1)+a(2)*(y-5.0)+a(3)*sin(f1)+a(4)*cos(f1)
     &                     +a(5)*sin(f2)+a(6)*cos(f2)
     &                     +a(7)*sin(f3)+a(8)*cos(f3)
      return
c
90    continue
      print*,' invalid function number  nfu=',nfu
      stop
      end
C***** parse.f *****
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine parse (string, numitems, item)
c     Extracts items separated by blanks from a string, and
c      returns them left-justified in NUMITEMS separate ITEM strings.
c     used with Parkfield C-meter data

      character*(*)  string, item(*)
      character*132  tempstring

      numitems = 0
      lenstr = len(string)
      tempstring = string
      istart = 1

 10   do 50 i = istart, lenstr
      if(tempstring(i:i) .ne. ' ') then
        ibegin = i
        nextblank = index(tempstring(i:lenstr), ' ')
        if (nextblank.eq.0) then
          iend = lenstr
          numitems = numitems + 1
          item (numitems) = tempstring(ibegin:iend)
          goto 90
        else
          iend = nextblank + (i-1) -1
          numitems = numitems + 1
          item (numitems) = tempstring(ibegin:iend)
          istart = iend + 1
          goto 10
        endif
      endif
 50   continue

 90   return
      end
      subroutine chron(nd,md,ic,nmod,t,dtime,d,a)
c  puts data into chronological order
c  code riped-off from numerical recipes piksrt.f
c
c  nd and md are dimensions of t, d, and a
c  t is time   dtime is same but double precision
c  d is data
c  a is the design matrix
c  ic is number of data
c  nmod number of model parameters
      dimension t(nd),d(nd),a(nd,md),ax(md)
      double precision dtime(nd), dtx,t
      do 12 j=2,ic
         tx=t(j)
         dtx=dtime(j)
         dx=d(j)
         do 9 k=1,nmod
9        ax(k)=a(j,k)

         do 11 i=j-1,1,-1
c  if time is a duplicate, add 0.00001 days to value (about 1 second)
         if (t(i) .eq. tx) t(i)=t(i)+0.00001
         if (t(i) .lt. tx) go to 10
           t(i+1)=t(i)
           dtime(i+1)=dtime(i)
           d(i+1)=d(i)
           do 13 k=1,nmod
13         a(i+1,k)=a(i,k)
11       continue
         i=0
10       t(i+1)=tx
         dtime(i+1)=dtx
         d(i+1)=dx
         do 15 k=1,nmod
15       a(i+1,k)=ax(k)
12    continue
      return
      end
      SUBROUTINE AMOEBA(P,Y,MP,NP,NDIM,FTOL,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &  ITER,
     &  covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
c from Numerical Recipes
      dimension d(max_data)
      double precision t_year(max_data),txx(max_data)
      dimension A(max_data,max_mod)
      double precision texp(10),t_start,t_stop
      INTEGER iter,mp,ndim,np,NMAX,ITMAX
      REAL ftol,p(mp,np),y(mp)
      PARAMETER (NMAX=20,ITMAX=54)
c      EXTERNAL funk
CU    USES amotry,funk
      INTEGER i,ihi,ilo,inhi,j,m,n
      REAL rtol,sum,swap,ysave,ytry,psum(NMAX),amotry
      dimension covarpl1(max_data,max_data),covarpl2(max_data,max_data),
     &  covarbp(max_data,max_data)
c      common covarpl1 ,covarbp,covarpl2
      dimension bexp(10), parm(10)
      character*7 exp_choice(10),exp_type(10)

      iter=0
1     do 12 n=1,ndim
        sum=0.
        do 11 m=1,ndim+1
          sum=sum+p(m,n)
11      continue
        psum(n)=sum
c        print*,' 1st psums',n,psum(n)
12    continue
2     ilo=1
      if (y(1).gt.y(2)) then
        ihi=1
        inhi=2
      else
        ihi=2
        inhi=1
      endif
      do 13 i=1,ndim+1
        if(y(i).le.y(ilo)) ilo=i
        if(y(i).gt.y(ihi)) then
          inhi=ihi
          ihi=i
        else if(y(i).gt.y(inhi)) then
          if(i.ne.ihi) inhi=i
        endif
13    continue
c      rtol=2.*abs(y(ihi)-y(ilo))/(abs(y(ihi))+abs(y(ilo)))
c do absolute tolerance
      rtol=abs(y(ihi)-y(ilo))
      if (rtol.lt.ftol) then
        swap=y(1)
        y(1)=y(ilo)
        y(ilo)=swap
        do 14 n=1,ndim
          swap=p(1,n)
          p(1,n)=p(ilo,n)
          p(ilo,n)=swap
14      continue
        return
      endif
c      if (iter.ge.ITMAX) pause 'ITMAX exceeded in amoeba'
       if (iter.ge.ITMAX) then
         PRINT*,  'Amoeba exceeding maximum iterations.'
          return
       end if
      iter=iter+2
      ytry=amotry(p,y,psum,mp,np,ndim,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &  ihi,-1.0,
     &     covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
      if (ytry.le.y(ilo)) then
        ytry=amotry(p,y,psum,mp,np,ndim,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &  ihi,2.0,
     &     covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
      else if (ytry.ge.y(inhi)) then
        ysave=y(ihi)
        ytry=amotry(p,y,psum,mp,np,ndim,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &    ihi,0.5,
     &     covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)
        if (ytry.ge.ysave) then
          do 16 i=1,ndim+1
            if(i.ne.ilo)then
              do 15 j=1,ndim
                psum(j)=0.5*(p(i,j)+p(ilo,j))
                p(i,j)=psum(j)
15            continue
c              y(i)=funk(psum)
c1234567890123456789012345678901234567890123456789012345678901234567890123456789
c       print*,' 1',psum(4)

        call funmin(YPRR,psum(1),psum(2),psum(3),psum(4),psum(5),
     &    npole,flow,fhigh,psum(6),psum(7),dt_sam/365.25,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,0,
     &     covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)


            endif
16        continue
          iter=iter+ndim
          goto 1
        endif
      else
        iter=iter-1
      endif
      goto 2
      END
      FUNCTION amotry(p,y,psum,mp,np,ndim,
     &   npole,flow,fhigh,dt_sam,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,
     &     ihi,fac,
     &    covarpl1,covarpl2,covarbp,
     &    nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)



      dimension d(max_data)
      double precision t_year(max_data),txx(max_data)
      dimension A(max_data,max_mod)
      INTEGER ihi,mp,ndim,np,NMAX
      REAL amotry,fac,p(mp,np),psum(np),y(mp)
      PARAMETER (NMAX=20)
      dimension covarpl1(max_data,max_data),covarpl2(max_data,max_data),
     &   covarbp(max_data,max_data)
      dimension bexp(10), parm(10)
      character*7 exp_choice(10),exp_type(10)
      double precision texp(10),t_start,t_stop

c      common covarpl1 ,covarbp,covarpl2
c      EXTERNAL funk
CU    USES funk
      INTEGER j
      REAL fac1,fac2,ytry,ptry(NMAX)
      fac1=(1.-fac)/ndim
      fac2=fac1-fac
      do 11 j=1,ndim
        ptry(j)=psum(j)*fac1-p(ihi,j)*fac2
c        print*,j,ptry(j),psum(j),fac1,p(ihi,j),fac2
11    continue
c1234567890123456789012345678901234567890123456789012345678901234567890123456789

c       print*,' 2',ptry(4)

        call funmin(YPRR,ptry(1),ptry(2),ptry(3),ptry(4),ptry(5),
     &    npole,flow,fhigh,ptry(6),ptry(7),dt_sam/365.25,
     &     t_year,d,txx,ic,max_data,max_mod,max_time
     &         ,A,nmod,ipl_flag_1,
     &     ipl_flag_2,ibp_flag,0,
     &     covarpl1,covarpl2,covarbp,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

      ytry=-YPRR
      if (ytry.lt.y(ihi)) then
        y(ihi)=ytry
        do 12 j=1,ndim
          psum(j)=psum(j)-p(ihi,j)+ptry(j)
          p(ihi,j)=ptry(j)
12      continue
      endif
      amotry=ytry
      return
      END
      subroutine output(x,e,max_mod,net,nbt,nrate,n_rat_chg,
     & nper,noff,rat_chg1,rat_chg2,off,per,sea,rate_norm,
     &  n_file_press,aux_norm,n_exp,texp,bexp,exp_choice,exp_type,
     & rat_chng_norm)
c  output results of model
      dimension x(max_mod),e(max_mod),aux_norm(max_mod)
      dimension bexp(10)
      character*7 exp_choice(10),exp_type(10)
      character*3 net
      double precision rat_chg1(82),rat_chg2(82),off(82),per(82),
     &   texp(10), rat_chng_norm(82)
      nc=0
      sea=0.

      do 64 i=1,nbt
        write(6,201)i,x(i),e(i)
201     format(' Nomimal value for baseline ',i3,f10.2,' +/- ',f10.2)
64    continue
      nc=nc+nbt
      if (nrate .eq. 1) 
     &      write(6,202)x(nc+1)/rate_norm,e(nc+1)/rate_norm
202   format(' Rate in units per year ',f16.4,' +/- ',f16.4)
      nc=nc+nrate
      if (n_rat_chg .gt. 0) then
        do 65 k=1,n_rat_chg
        itime1=int(rat_chg1(k))
        dec_time1=rat_chg1(k)-float(itime1)
        itime2=int(rat_chg2(k))
        dec_time2=rat_chg2(k)-float(itime2)

        if (net .eq. 'otr') then
		  call inv_jul_time(itime1,nyr,jul)
		  call inv_jul_time(itime2,nyr2,jul2)
          write(6,203)k,nyr,jul+dec_time1,nyr2,jul2+dec_time2,
     &       x(nc+k)/rat_chng_norm(k),e(nc+k)/rat_chng_norm(k)
        else
          call invcal(itime1,nyr,mn,idate)
          call invcal(itime2,nyr2,mn2,idate2)
          write(6,204)k,nyr,mn,idate+dec_time1,
     &      nyr2,mn2,idate2+dec_time2,
     &       x(nc+k)/rat_chng_norm(k),e(nc+k)/rat_chng_norm(k)
        end if
65      continue
      end if
      nc=nc+n_rat_chg
203   format(' Rate change number ',i3,' between ',i5,f10.3,
     & ' and ',i5,f10.3,
     & ' is ',f16.4,' +/- ',f16.4)
204   format(' Rate change number ',i3,' between ',2i5,f6.3,
     & ' and ',2i5,f6.3,
     & ' is ',f12.4,' +/- ',f10.4)
      if (nper .gt. 0) then
         do 66 k=1,nper
         fmag=x(nc+2*k-1)**2 + x(nc+2*k-0)**2
         fmag=sqrt(fmag)
         e_mag=(x(nc+2*k-1)**2)*(e(nc+2*k-1)**2)
     &    +(x(nc+2*k-0)**2)*(e(nc+2*k-0)**2)
         e_mag=sqrt(e_mag)/fmag
         write(6,205) per(k),x(nc+2*k-1),e(nc+2*k-1), 
     &   x(nc+2*k-0),e(nc+2*k-0), fmag,e_mag
         if (k .eq. 1) sea=fmag
66       continue
      end if
      nc=nc+2*nper
205   format(' Period of ',f8.3,' days,  cos amp= ',f12.2,' +/-',f10.2,
     & '  sin amp= ',f12.2,' +/-',f10.2,'  magnitude= ',
     &  f12.2,' +/-',f10.2)
      if (noff .gt. 0) then
        do 67 k=1,noff
        itime=int(off(k))
        dec_time=off(k)-float(itime)
        if (net .eq. 'otr') then
          call inv_jul_time(itime,nyr,jul)
          write(6,206)k,nyr,jul+dec_time,x(nc+k),e(nc+k)
        else
          call invcal(itime,nyr,mn,idate)
          write(6,207)k,nyr,mn,idate+dec_time,x(nc+k),e(nc+k)
        end if
67      continue
      end if
206   format(' Offset number ',i5,' at ',i5,f10.3,
     & ' is ',f10.2,' +/- ',f8.2)
207   format(' Offset number ',i3,' at ',i5,i3,f8.3,
     & ' is ',f10.2,' +/- ' ,f8.2)
      nc=nc+noff
      ikk=n_exp
c      nc=nc+n_file_press
      nfix=0      
      if (n_exp .ne. 0) then
c      do 680 k=1,n_exp
c680   if (exp_choice(k) .eq. "float") nfloat=nfloat+1
c      print*,"nfloat=",nfloat
      do 68 k=1,n_exp

         if (exp_choice(k) .ne. "float") then
         
         nfix=nfix+1
         itime=int(texp(k))
         dec_time=texp(k)-float(itime)
        if (net .eq. 'otr') then
c         print*,' nc+k', nc+k,' k',k
          call inv_jul_time(itime,nyr,jul)
          write(6,208)k,nyr,jul+dec_time,x(nc+k),e(nc+k),bexp(k)
        else
          call invcal(itime,nyr,mn,idate)
          write(6,209)k,nyr,mn,idate+dec_time,x(nc+k),e(nc+k),bexp(k)
        end if

        else
         ikk=ikk+1
         nc=nc+n_file_press
         itime=int(texp(k))
         dec_time=texp(k)-float(itime)
c         print*,'nc=',nc,' k=',k,' ikk=',ikk,nc+0+ikk
        if (net .eq. 'otr') then
c           print*,' nc+k', nc+k,' nc+k+n_exp', nc+k+n_exp
c          print*,nc+k,nc+k+n_file_press+n_exp
          call inv_jul_time(itime,nyr,jul)
c          print*,nc,k,n_file_press,n_exp,nc+k,nc+k+n_file_press+n_exp
          write(6,2081)k,nyr,jul+dec_time,x(nc+k),e(nc+k),
     &      bexp(k),e(nc+0+ikk)
c     &      bexp(k),e(nc+k+n_file_press+n_exp)
        else
          call invcal(itime,nyr,mn,idate)
          write(6,2091)k,nyr,mn,idate+dec_time,x(nc+k),e(nc+k),
     &      bexp(k),e(nc+0+ikk)
c     &      bexp(k),e(nc+k+n_file_press+n_exp)
        end if
         nc=nc-n_file_press

        end if
68      continue 
208   format(' Exponential number ',i5,' at ',i5,f10.3,
     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ', e12.5,' yrs')
c     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ',f10.5,' yrs')

209   format(' Exponential number ',i3,' at ',i5,i3,f8.3,
     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ', e12.5,' yrs')        
c     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ',f10.5,' yrs')        
2081  format(' Exponential number ',i5,' at ',i5,f10.3,
     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ',e10.5,
     &  ' +/- ',e11.5,' yrs')
2091  format(' Exponential number ',i3,' at ',i5,i3,f8.3,
     & ' is ',f10.2,' +/- ',f8.2,'  Time constant is: ',e10.5,
     &  ' +/- ',e11.5,' yrs')        
      end if
c      print*,'n_file_press=',n_file_press,' nc=',nc
c      nc=nc-n_file_press
c  don't need to add to nc; the exponental is 'out of order'; nc was added to in noff.
c      nc=nc
c      nc=nc+n_exp-ikk
c      print*,' nc=',nc,' ikk=',ikk
c      nc=nc-ikk
c      print*,' new nc after adding n_exp', nc
      nc=nc+nfix
      if (n_file_press .ne. 0) then
        do 679 k=1,n_file_press
c        print*,'nc+k',nc+k,'x(nc+k)',x(nc+k),'aux_norm(k)',aux_norm(k)
        write(6,210)k,x(nc+k)/aux_norm(k),e(nc+k)/aux_norm(k)
c        print*,k,x(nc+k),e(nc+k),aux_norm(k)
679     continue
      end if
210   format(' response of ', i3, ' input function',f13.5,' +/- ',f12.5)


      return
      end
      SUBROUTINE realft(data,n,isign)
      INTEGER isign,n
      REAL data(n)
CU    USES four1
      INTEGER i,i1,i2,i3,i4,n2p3
      REAL c1,c2,h1i,h1r,h2i,h2r,wis,wrs
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      theta=3.141592653589793d0/dble(n/2)
      c1=0.5
      if (isign.eq.1) then
        c2=-0.5
        call four1(data,n/2,+1)
      else
        c2=0.5
        theta=-theta
      endif
      wpr=-2.0d0*sin(0.5d0*theta)**2
      wpi=sin(theta)
      wr=1.0d0+wpr
      wi=wpi
      n2p3=n+3
      do 11 i=2,n/4
        i1=2*i-1
        i2=i1+1
        i3=n2p3-i2
        i4=i3+1
        wrs=sngl(wr)
        wis=sngl(wi)
        h1r=c1*(data(i1)+data(i3))
        h1i=c1*(data(i2)-data(i4))
        h2r=-c2*(data(i2)+data(i4))
        h2i=c2*(data(i1)-data(i3))
        data(i1)=h1r+wrs*h2r-wis*h2i
        data(i2)=h1i+wrs*h2i+wis*h2r
        data(i3)=h1r-wrs*h2r+wis*h2i
        data(i4)=-h1i+wrs*h2i+wis*h2r
        wtemp=wr
        wr=wr*wpr-wi*wpi+wr
        wi=wi*wpr+wtemp*wpi+wi
11    continue
      if (isign.eq.1) then
        h1r=data(1)
        data(1)=h1r+data(2)
        data(2)=h1r-data(2)
      else
        h1r=data(1)
        data(1)=c1*(h1r+data(2))
        data(2)=c1*(h1r-data(2))
        call four1(data,n/2,-1)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software YaAV.
      SUBROUTINE four1(data,nn,isign)
      INTEGER isign,nn
      REAL data(2*nn)
      INTEGER i,istep,j,m,mmax,n
      REAL tempi,tempr
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software YaAV.
      function secnds(d)
c  f90 version of the f77 routine secnds
      call cpu_time(time)
      secnds=time
      return
      end
      subroutine model_fit(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop)

c  Subroutine check whether exp_fit or omori_fit has any "floats";
c    if so, used downhill simplex to estimate the optimal time constants
c    if not, just runs calcres
c
c max_data  dimension of data
c max_parm  dimension of num parameters
c ic number of data
c nmod number of parameters
c ax  design matrix
c d  data
c t  time
c res  residuals
c covinv  inverse covariance matrix
c covar  covariance matrix
c iswitch  outputs the model and its error if set to 1
c  x  the model
c  e  the error
c  nexp  number of exponentials both "fix" and "float"
c  bexp  are the time constants for the exponential (floaters are trial time constrants
c  texp  are the T_o of each of the exponentials
c  exp_choice is either "fix" or "float"
c  t_start  time, in days of first pt in time series
c  t_stop    time, in day of last pt in time series
c

      dimension A(max_data,max_parm),x(max_parm),
     &  covinv(max_data,max_data),
     &  d(max_data),res(max_data)
      dimension a1(max_parm,max_data),a2(max_parm,max_parm),
     &  ai(max_parm,max_parm),wz(5000)
      dimension covar(max_data,max_data)
      dimension e(max_parm)
      double precision texp(10),t_start,t(max_data),t_stop
      dimension bexp(10), Anor(max_parm)
      character*7 exp_choice(10),exp_type(10)
      dimension sres(11),spar(11,10)
      double precision ad2(max_parm,max_parm),wzd(5000),evd(max_parm)
      mdmax=max_data
      maxnmod=max_parm
      nmod_orig=nmod
c      print*,' in model_fit, mdmax=',mdmax,' maxnmod=',maxnmod,
c     & ' nmod_orig=',nmod_orig
      rewind(23)
      read(23,*)idum
      idum=-1*abs(idum)
c      print*," nexp=",nexp," ic=",ic," t_start=",t_start
c      print*,(k,exp_choice(k),k=1,nexp)
c  For the initial solution
      call modify_A(A,max_data,max_parm,ic,nmod,t,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start)

c      print*," nmod_orig=",nmod_orig,"  nmod=", nmod," nexp=",nexp
c      print*,' bexp=',(k,bexp(k),k=1,nexp)
c      do 2222 i=1,10
c        print*,i,d(i),(A(i,j),j=1,nmod)
c2222   continue
c      do 2223 i=1,10
c        print*,i,(covinv(i,j),j=1,10)
c        print*,i,(covar(i,j),j=1,10)
c2223   continue

      call calcres(max_data,max_parm,ic,nmod,A,d,res,
     &  covinv,covar,iswitch,x,e)
c      print*, "finish calc_res",(i,x(i),e(i),i=1,nmod)
c      write(13,1301)(i,x(i),e(i),i=1,nmod)

c1301   format(60(3x,i5,f15.3,1x,f15.3))
      call sumres(covinv,res,max_data,ic,sum)

c      print*, " Chi^2 is", sum," RMS=",sqrt(sum/float(ic-nmod))
      sres(1)=sum

c
c  do a second, third, etc solution depending upon the number of "floaters"
c
      nsim=0
      nmod=nmod_orig
      iflag=0
      tmin=99999.
      do 111 i=2,ic
        dt=t(i)-t(i-1)
        if (dt .lt. tmin) tmin=dt
111   continue
      tmax=t(ic)-t(i)
      kcnt=0
c      print*,' nexp=',nexp
      do 1 k=1,nexp
        if (exp_choice(k) .eq. "float") then
        kcnt=kcnt+1
        iflag=1
        nsim=nsim+1
        do 5 kk=1,11
5       spar(kk,nsim)=alog10(bexp(k))
c   use a random number generator to dither exponent
        icount=0
4       continue
c        write(89,*)'icount=   X',icount
        if (icount .ne. 10)  then
c          write(89,*)' idum=',idum
c          write(91,*)' start',idum,ran
          ran=ran1(idum)
c          write(91,*)' finish',idum,ran
c          write(89,*)' random number is ', ran, ' icount=',icount,
c     &  ' idum',idum
          idum=int(abs(1000000*ran))
          ran=5.5*(ran-0.5)
c          write(89,*)' modified ran=',ran
c  if dither is too small, try again
        if (abs(ran) .lt. 0.2) write(89,*)'ran=',ran,' icount=',icount
          if (abs(ran) .lt. 0.2)  go to 4
          bexp_orig=bexp(k)
c        bexp(k)=(1.0+ran)*alog10(bexp(k)) 
         bexp(k)=ran+alog10(bexp(k)) 
          bexp(k)= 10.0**bexp(k)
c        if ((bexp(k) .lt. 0.0001) .or. (bexp(k) .gt. 100.))  then
c        print*,k,bexp(k),tmin/100.,tmax*10,bexp_orig,ran
          if ((bexp(k) .lt. tmin/(365.0*10.)) .or. 
     &       (bexp(k) .gt. 365.*10.*tmax))  then
             bexp(k)=bexp_orig
c           write(89,*)'icount = ', icount,'  bexp=',bexp(k)
             icount=icount+1
             go to 4
          end if
        else
c   got stuck in a loop; just assign random number for bexp()
         print*, ' stuck in loop; bailed'
         ran=ran1(idum)
         ran=ran-0.5
         
         bexp(k)=10**ran
         write(89,*)' bexp(k)=',bexp(k),' ran=',ran
         

        end if
c  If too close the the max time constant; change!
c        print*,' test bexp(k)=',bexp(k), ' 365.*10*tmax=',365.*10*tmax,
c     &    ' abs',abs(bexp(k)-365.*10*tmax)/(365*10*tmax)
c         if (abs(bexp(k)-365.*10*tmax)/(365*10*tmax) .lt .1)
c     &      bexp(k)=tmax/(10.*365.)

c        write(89,*)" new value of bexp(k)", bexp(k) 
        call modify_A(A,max_data,max_parm,ic,nmod,t,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start)

c        print*,' bexp=',(j,bexp(j),j=1,nexp)
c        print*," nmod_orig=",nmod_orig,"  nmod=", nmod
        call calcres(max_data,max_parm,ic,nmod,A,d,res,
     &  covinv,covar,0,x,e)
c        print*, "finish calc_res 2",(i,x(i),e(i),i=1,nmod)
c        write(13,130)(x(i),e(i),i=1,nmod)
c130     format(30(3x,f15.3,1x,f15.3))
        call sumres(covinv,res,max_data,ic,sum)
c        spar(k+1,nsim)=alog10(bexp(k))
c        sres(k+1)=sum
c        print*,'k+1',k+1,' nsim',nsim, 
c     &  bexp(k),spar(k+1,nsim),sres(k+1)
        spar(kcnt+1,nsim)=alog10(bexp(k))
        sres(kcnt+1)=sum
c        print*,'kcnt+1',kcnt+1,' nsim',nsim,'k=',k,
c     &  bexp(k),spar(kcnt+1,nsim),sres(kcnt+1)
c        print*, " Chi^2 is", sum," RMS=",sqrt(sum/float(ic-nmod))  
        bexp(k)=bexp_orig
        nmod=nmod_orig    
        end if

1     continue
      rewind(23)
      write(23,*)idum

c131     format(90(3x,f15.3,1x,f15.3))
c  check to see if we need to iterate to find best fit time constants
      if (iflag .eq. 0) then
        write(13,130)(x(i),e(i),i=1,nmod)
        return
      end if
      do 3 k=1,nsim+1
c       print*, ' input to Amoeba, k=',k,sres(k),
c     &       (spar(k,j),10.0**spar(k,j),j=1,nsim)
c
3       write(89,*) ' input to Amoeba, k=',k,sres(k),
     &       (10.0**spar(k,j),j=1,nsim)
c
c  use downhill simplex to get best fit time-constants
c
      ftol=0.00001

      call AMOEBA_mod(spar,sres,11,10,nsim,FTOL,ITER,
     & max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop   ) 

c      ikkk=0
c      print*,' Number of iterations is ',ITER
c      if (ikkk .eq. 0 ) stop 
c
c   figure out the optimal solution
c
c      do 30 k=1,nsim+1
c       print*, ' input to Amoeba, k=',k,sres(k),
c     &       (spar(k,j),10.0**spar(k,j),j=1,nsim)
c30    continue
      fmin=1.e+30
      kcnt=0
      do 10 i=1,nsim+1
c        print*,i,sres(i),(10.0**spar(i,k),k=1,nsim)
        if (sres(i) .lt. fmin) then
        fmin=sres(i)
c        ii=i
c        do 11 j=1,nexp
c          write(89,*)i,j,exp_choice(j),(10.0**spar(ii,i),i=1,nsim)
c          if (exp_choice(j) .eq. "float") then
c             kcnt=kcnt+1
c             bexp(j)=10.0**spar(ii,kcnt)
c          end if
c11      continue
        end if
10    continue
c      print*," Best fit ",fmin,(bexp(j),j=1,nexp)
      write(89,*)" Best fit ",fmin,(bexp(j),j=1,nexp)
      write(89,*) " "
      nmod=nmod_orig
        call modify_A(A,max_data,max_parm,ic,nmod,t,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start)
        call calcres(max_data,max_parm,ic,nmod,A,d,res,
     &  covinv,covar,0,x,e)
c        print*, "finish calc_res",(x(i),e(i),i=1,nmod)

c   put the estimate of exponential into list of x(i)
         ix=0
         do 18 k=1,nexp
           if (exp_choice(k) .eq. "float") then
           ix=ix+1
           x(nmod+ix)=bexp(k)
           end if
18       continue

        call sumres(covinv,res,max_data,ic,sum)
c
c  estimate the standard error on all model parameters by taking first differences
c  and doing the appropriate inversions
c  
         
      if (iswitch .eq. 1 ) then

c      nmod=nmod_orig
      do 185 j=1,nmod
185   Anor(j)=1.0


c  next, add columns associated with the time-constants
        kexp=0
        do 19 kexp=1,nexp
          if (exp_choice(kexp) .eq. "float") then
c          kexp=kexp+1
c          print*,'nmod,kexp,kkexp bexp(kexp)=',
c     &      nmod,kexp,kkexp,bexp(kexp)
c        print*,'texp(kexp)', texp(kexp),x(nmod_orig+kexp),x(nmod+kexp)
          xxd=1.1
          if (bexp(kexp) .gt. 1.0) xxd=0.9

          Amin=1.0e+20
          Amax=-1.0e+20
          nmod=nmod+1
c            print*,' x(nmod-1)=',x(nmod-1),' nmod-1=',nmod-1, 
c     &      x(nmod_orig+kexp)
            do 20 j=1,ic
              A(j,nmod)=0.0
              if (exp_type(kexp) .eq. "e") then
              if (t(j) .ge. texp(kexp)-t_start) then
c              e1=1.0-exp(-(t(j)-(texp(kexp)-t_start))
c     &           /(365.25*bexp(kexp)))
c              e2=1.0-exp(-(t(j)-(texp(kexp)-t_start))
c     &           /(365.25*xxd*bexp(kexp))) 
c             A(j,nmod)=1.*(e1-e2)/(1.0*(bexp(kexp)-xxd*bexp(kexp)))
c     &                *x(nmod_orig+kexp)
c   use the derrivative here  ( need to be careful about units between days and years for time
              tuuu=(t(j)-(texp(kexp)-t_start))
              A(j,nmod)=(-1.0*tuuu/( (365.25*bexp(kexp))**2 ))
     &              * exp(-1.0*tuuu/(365.25*bexp(kexp) ) )
             A(j,nmod)=A(j,nmod)*x(nmod_orig+kexp) * 365.25
             end if
             end if
             if (exp_type(kexp) .eq. "o") then
              if (t(j) .gt. texp(kexp)-t_start) then


              e1=alog10(abs(bexp(kexp)) +
     &            (sngl(t(j)-(texp(kexp)-t_start))/365.25))
              e2=alog10(abs(bexp(kexp))*xxd +
     &            (sngl(t(j)-(texp(kexp)-t_start))/365.25))
             A(j,nmod)=1.*(e1-e2)/(1.0*(bexp(kexp)-xxd*bexp(kexp)))
     &                *x(nmod_orig+kexp)
c             print*,j,bexp(kexp),e1,e2,A(j,nmod)
c             print*,"  ",e1-e2,xxd,x(nmod_orig+kexp)
c             print*,"    ", (bexp(kexp)-xxd*bexp(kexp))
             end if
             end if
             if (exp_type(kexp) .eq. "m" ) then
              if (t(j) .gt. texp(kexp)-t_start) then
              e1=alog10( 1.0 + 
     &            (sngl(t(j)-(texp(kexp)-t_start))/365.25)
     &             /abs(bexp(kexp)) )
              e2=alog10( 1.0 + 
     &            (sngl(t(j)-(texp(kexp)-t_start))/365.25)
     &             /abs(bexp(kexp))*xxd )
             A(j,nmod)=1.*(e1-e2)/(1.0*(bexp(kexp)-xxd*bexp(kexp)))
     &                *x(nmod_orig+kexp)

             end if
             end if
             if (A(j,nmod) .lt. Amin) Amin=A(j,nmod)
             if (A(j,nmod) .gt. Amax) Amax=A(j,nmod)
c          write(87,*)j,t(j),(A(j,k),k=1,nmod),bexp(kexp),e1,e2
c          write(86,*)(A(j,k),k=1,nmod)

20         continue
           range=Amax-Amin
           Anor(nmod)=200.0/range
c           Anor(nmod)=1.0/abs(x(nmod_orig+kexp))
c           Anor(nmod)=1.0/(range*abs(x(nmod_orig+kexp)))
           Anor(nmod)=1.0/(range)
c           print*,nmod,kexp,' nmod and kexp'
           print*,"max, min, range", Amax,Amin,range,' Norm',
     &    Anor(nmod),' x(nmod_orig+kexp)=',x(nmod_orig+kexp)
c   renormalize the nmod column
           do 21 j=1,ic
21         A(j,nmod)=A(j,nmod)*Anor(nmod)
c     if bexp is 'out of range' zero out the A matrix
           if ((bexp(kexp) .le. tmin/(365.0*5.)) .or.
     &         (bexp(kexp) .gt. 5.*tmax/365.))  then
               do 213 j=1,ic
213            A(j,nmod)=0.0
           end if
          end if
19      continue 
      mdmax=max_data
      maxnmod=max_parm

c
c  compute At*covinv
c
      call sgemm('T','N',nmod,ic,ic,1.0,A,max_data,covinv,max_data,
     & 0.0,a1,max_parm)
c
c compute At*covinv*A   A1*A
c
      call  sgemm('N','N',nmod,nmod,ic,1.0,a1,max_parm,A,max_data,
     & 0.0,a2,max_parm)
      do 120 i=1,nmod
      do 119 j=1,nmod
119    ad2(i,j)=a2(i,j)
120    continue

c
c invert At*covinv*A
c
      call dsyev('V','L',nmod,ad2,max_parm,evd,wzd,5000,ier)
c      call ssyev('V','L',nmod,a2,max_parm,e,wz,500,ier)
      print*,"In time constant routine,  ier =",ier
      print*,' eigenvalues',(evd(k),k=1,nmod)
      ixx=0
      do 2221 k=nmod,1,-1
        if (abs(evd(k)/evd(nmod)) .gt. 1.0e-09) ixx=ixx+1
2221  continue
      do 220 i=1,nmod

      do 221 j=1,nmod
        at=0.0
        do 222 k=nmod,nmod-ixx+1,-1
c         if (abs(evd(k)/e(nmod)) .gt. 1.0e-07) then
            at=at+ad2(i,k)*ad2(j,k)/evd(k)
c            ixx=ixx+1
c         end if
c        if (e(k) .gt. 0) 
c    &     at=at+a2(i,k)*a2(j,k)/e(k)
222     continue
221   ai(i,j)=at
c      print*," ai (i,j) i=",i,(ai(i,j),j=1,nmod)
220   continue
      print*,' Using',ixx,' out of', nmod,' eigenvalues'

      do 330 i=1,nmod
      print*,'i=',i,' ai=',ai(i,i),' sqrt',sqrt(ai(i,i)),
     &   ' Anor=',Anor(i)
c     &,sqrt(ai(i,i))*Anor(i)
      if (ai(i,i) .gt. 0) then
         e(i)=sqrt(ai(i,i))*Anor(i)
         else
         e(i)=1.0e+06
c         e(i)=sqrt(-ai(i,i))*Anor(i)
      end if
c      print*,sqrt(ai(i,i))*Anor(i),e(i)
330   continue
      


      
      end if
c      write(88,*)iswitch,nmod,ix
      if ( iswitch .eq. 1) then
        write(13,130)(x(i),e(i),i=1,nmod)

c        write(88,*)" ERROR calc"
130     format(90(3x,f15.3,1x,f15.3))
      else
        write(13,130)(x(i),e(i),i=1,nmod),(x(nmod+i),0.0,i=1,ix)
c        write(88,*)" no error"
      end if
      nmod=nmod_orig
      return
      end
      subroutine modify_A(A,max_data,max_parm,ic,nmod,t,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start)
c  modifies A matrix to include exponential terms
      dimension A(max_data,max_parm)
      dimension bexp(10)
      double precision texp(10),t_start,t(max_data),t_stop
      character*7 exp_choice(10),exp_type(10)
c
c  for each exp_choice equal to "float", add an additional column to A
c
      tmax=t(1)
      tmin=t(1)
      dtmin=99999.
      ratmax=5.0
      do 20 i=2,ic
        if (t(i) .ge. tmax) tmax=t(i)
        if (t(i) .lt. tmin) tmin=t(i)
        if (t(i)-t(i-1) .lt. dtmin) dtmin=t(i)-t(i-1)
20    continue

      
      do 1 kexp=1,nexp
        if (exp_choice(kexp) .eq. "float") then
        nmod=nmod+1
c        print*,kexp,exp_choice(kexp),texp(kexp),bexp(kexp)
c  test for bexp being too big or too small
        iflagsmall=0
        if (bexp(kexp) .lt.  dtmin/(365.25*ratmax) ) then
           bexp(kexp)= dtmin/(365.25*ratmax) 
           iflagsmall=0
        end if
        if (bexp(kexp) .gt. (tmax-tmin)*ratmax/365.25 ) 
     &        bexp(kexp)= (tmax-tmin)*ratmax/365.25
        do 2 j=1,ic
        A(j,nmod)=0.0
        if (exp_type(kexp) .eq. "e") then
        if (t(j) .ge. texp(kexp)-t_start) 
     &    A(j,nmod)=1.0-exp(-(t(j)-(texp(kexp)-t_start))
     &           /(365.25*bexp(kexp)))
         end if
        if (exp_type(kexp) .eq. "o") then
        if ((t(j) .gt. texp(kexp)-t_start) .and. (iflagsmall .eq. 0)) 
     &    A(j,nmod)=alog10(abs(bexp(kexp)) +
     &     (sngl(t(j)-(texp(kexp)-t_start))/365.25))
        if ((t(j) .gt. texp(kexp)-t_start) .and. iflagsmall .eq. 1) 
     &    A(j,nmod)=alog10((sngl(t(j)-(texp(kexp)-t_start))/365.25))
c     &             -alog10(abs(bexp(k)))
         end if
        if (exp_type(kexp) .eq. "m") then
        if ((t(j) .gt. texp(kexp)-t_start) .and. (iflagsmall .eq. 0))
     &    A(j,nmod)=alog10( 1.0 +
     &     (sngl(t(j)-(texp(kexp)-t_start))/365.25)/abs(bexp(kexp)) )
        if ((t(j) .gt. texp(kexp)-t_start) .and. (iflagsmall .eq. 1))
     &    A(j,nmod)=alog10((sngl(t(j)-(texp(kexp)-t_start))/365.25))
     &             -alog10(abs(bexp(k)))
         end if
c        write(89,*)j,t(j),(texp(kexp)-t_start),A(j,nmod)
2       continue

        end if

1     continue
      return
      end
      subroutine sumres(covinv,res,max_data,ic,sum)
      dimension covinv(max_data,max_data), res(max_data)
c  calculate RMS residuals
      sum=0.
      do 3 i=1,ic
      resA=0.
        do 4 j=1,ic
        resA=resA+res(i)*covinv(i,j)*res(j)
4       continue
c      print*,i,res(i)
      sum=sum+resA
3     continue
      return
      end
      SUBROUTINE AMOEBA_mod(P,Y,MP,NP,NDIM,FTOL,ITER,
     &  max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop  )
c      PARAMETER (NMAX=20,ALPHA=1.0,BETA=0.5,GAMMA=2.0,ITMAX=500)
      PARAMETER (NMAX=20,ALPHA=1.0,BETA=0.5,GAMMA=2.0)
      DIMENSION P(MP,NP),Y(MP),PR(NMAX),PRR(NMAX),PBAR(NMAX)
      dimension A(max_data,max_parm),x(max_parm),
     &  covinv(max_data,max_data),
     &  d(max_data),res(max_data)
      dimension covar(max_data,max_data)
      dimension e(max_parm)
      double precision texp(10),t_start,t(max_data),t_stop
      dimension bexp(10)
      character*7 exp_choice(10),exp_type(10)
      MPTS=NDIM+1
      ITMAX=30*(NDIM)
c      print*,'NDIM=',NDIM
c      print*,'Y',(Y(i),i=1,MPTS)
      ITER=0
1     ILO=1
      IF(Y(1).GT.Y(2))THEN
        IHI=1
        INHI=2
      ELSE
        IHI=2
        INHI=1
      ENDIF
      DO 11 I=1,MPTS
        IF(Y(I).LT.Y(ILO)) ILO=I
        IF(Y(I).GT.Y(IHI))THEN
          INHI=IHI
          IHI=I
        ELSE IF(Y(I).GT.Y(INHI))THEN
          IF(I.NE.IHI) INHI=I
        ENDIF
11    CONTINUE
      RTOL=2.*ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))
c      write(89,100)IHI,Y(IHI),ILO,Y(ILO),ITER,ITMAX,RTOL,FTOL
100   format(2(I5,f15.6),2i5,2f15.5)
c      print*,' RTOL=',RTOL,'  FTOL=',FTOL
      IF(RTOL.LT.FTOL)RETURN
c      IF(ITER.EQ.ITMAX) PAUSE 'Amoeba exceeding maximum iterations.'
      IF(ITER.EQ.ITMAX) then
        write(89,*) 'Amoeba exceeding maximum iteration'
        return 
      end if
      ITER=ITER+1
      DO 12 J=1,NDIM
        PBAR(J)=0.
12    CONTINUE
      DO 14 I=1,MPTS
        IF(I.NE.IHI)THEN
          DO 13 J=1,NDIM
            PBAR(J)=PBAR(J)+P(I,J)
13        CONTINUE
        ENDIF
14    CONTINUE
      DO 15 J=1,NDIM
        PBAR(J)=PBAR(J)/NDIM
        PR(J)=(1.+ALPHA)*PBAR(J)-ALPHA*P(IHI,J)
15    CONTINUE
c      YPR=FUNK(PR)
      YPR=
     &   fmodel_fit_A(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop,PR)
c      ITER=ITER+1
      IF(YPR.LE.Y(ILO))THEN
        DO 16 J=1,NDIM
          PRR(J)=GAMMA*PR(J)+(1.-GAMMA)*PBAR(J)
16      CONTINUE
c        YPRR=FUNK(PRR)
        YPRR=
     &   fmodel_fit_A(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop,PRR)
c        ITER=ITER+1
        IF(YPRR.LT.Y(ILO))THEN
          DO 17 J=1,NDIM
            P(IHI,J)=PRR(J)
17        CONTINUE
          Y(IHI)=YPRR
        ELSE
          DO 18 J=1,NDIM
            P(IHI,J)=PR(J)
18        CONTINUE
          Y(IHI)=YPR
        ENDIF
      ELSE IF(YPR.GE.Y(INHI))THEN
        IF(YPR.LT.Y(IHI))THEN
          DO 19 J=1,NDIM
            P(IHI,J)=PR(J)
19        CONTINUE
          Y(IHI)=YPR
        ENDIF
        DO 21 J=1,NDIM
          PRR(J)=BETA*P(IHI,J)+(1.-BETA)*PBAR(J)
21      CONTINUE
c        YPRR=FUNK(PRR)
        YPRR=
     &   fmodel_fit_A(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop,PRR)
c        ITER=ITER+1
        IF(YPRR.LT.Y(IHI))THEN
          DO 22 J=1,NDIM
            P(IHI,J)=PRR(J)
22        CONTINUE
          Y(IHI)=YPRR
        ELSE
          DO 24 I=1,MPTS
            IF(I.NE.ILO)THEN
              DO 23 J=1,NDIM
                PR(J)=0.5*(P(I,J)+P(ILO,J))
                P(I,J)=PR(J)
23            CONTINUE
c              Y(I)=FUNK(PR)
              Y(I)=
     &   fmodel_fit_A(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop,PR)
c            ITER=ITER+1
            ENDIF
24        CONTINUE
        ENDIF
      ELSE
        DO 25 J=1,NDIM
          P(IHI,J)=PR(J)
25      CONTINUE
        Y(IHI)=YPR
      ENDIF
      GO TO 1
      END
      function fmodel_fit_A(max_data,max_parm,ic,nmod,A,t,d,res,
     &  covinv,covar,iswitch,x,e,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start,t_stop,parm)

c  function called by Downhill simplex; the sum of square residuals are
c    output to AMOEBA_mod
c max_data  dimension of data
c max_parm  dimension of num parameters
c ic number of data
c nmod number of parameters
c ax  design matrix
c d  data
c t  time
c res  residuals
c covinv  inverse covariance matrix
c covar  covariance matrix
c iswitch  outputs the model and its error if set to 1
c  x  the model
c  e  the error
c  nexp  number of exponentials both "fix" and "float"
c  bexp  are the time constants for the exponential (floaters are trial time constrants
c  texp  are the T_o of each of the exponentials
c  exp_choice is either "fix" or "float"
c  t_start  time, in days of first pt in time series
c  t_stop    time, in day of last pt in time series
c   parm is the trial time constants for expontials/omori
c

      dimension A(max_data,max_parm),x(max_parm),
     &  covinv(max_data,max_data),
     &  d(max_data),res(max_data)
      dimension covar(max_data,max_data) 

      dimension e(max_parm)
      double precision texp(10),t_start,t(max_data),t_stop
      dimension bexp(10), parm(10)
      character*7 exp_choice(10),exp_type(10)
      mdmax=max_data
      maxnmod=max_parm
      nmod_orig=nmod
c      print*,' In function fmodel_fit'
c      print*," nexp=",nexp," ic=",ic," t_start=",t_start
c      print*,(k,exp_choice(k),k=1,nexp)
c  For the initial solution
      ix=0
c      print*," "
c      print*," "
      do 1 i=1,nexp
      if (exp_choice(i) .eq. "float") then
         ix=ix+1
c         if (parm(ix) .lt. -4.) parm(ix)=-4.0
c         if (parm(ix) .gt. 2.0) parm(ix)=2.0
         bexp(i)=10.0**parm(ix)

c         print*, "Try ",ix,parm(ix),bexp(i)
      end if
1     continue
      call modify_A(A,max_data,max_parm,ic,nmod,t,
     &  nexp,bexp,texp,exp_choice,exp_type,t_start)

c      print*," nmod_orig=",nmod_orig,"  nmod=", nmod
      call calcres(max_data,max_parm,ic,nmod,A,d,res,
     &  covinv,covar,0,x,e)
c      write(13,130)(x(i),e(i),i=1,nmod)
c130   format(30(3x,f15.3,1x,f15.3))
c      print*, "finish calc_res",(x(i),e(i),i=1,nmod)
      call sumres(covinv,res,max_data,ic,sum)

c      print*, " Chi^2 is", sum," RMS=",sqrt(sum/float(ic-nmod))
      nmod=nmod_orig
      fmodel_fit_A=sum
      write(89,*)sum,(10.0**parm(i),i=1,ix)
         
      return
      end
      subroutine makeMatrix(irow,max,f,covar,nobs,iflip,mmax)
c  make covariance matrix, covar, from the filter function,f
c  Initially, builds covariance matrix on the assumption unformally sampled observations
c    with no missing data
c  Then, selects rows and columns specified by irow to build actual covariance matrix
c
c     irow  vector contain row numbers (or column numbers) to select out of complete covariance matrxi
c     max  total size of covariance matrix (and f) assuming no missing data
c     f  filter function (length max)
c     covar  covariance matrix
c     nobs  number of data
c     iflip  if 0; for calculate covariance; if 1--calculating inverse covariance
c
c      dimension covar(8103,8103), scr(8103,8103),f(8103)
c      dimension covar(8103,8103), scr(8103,8103),f(mmax)
      dimension covar(8103,8103), scr(max,max),f(mmax)
c  max dim of scr seems to be 18001,18001 -- any larger, the code crashes immediately
c      dimension covar(8103,8103), scr(18001,18001),f(mmax)
      integer irow(8103)
c      print*,' in makeMatrix', m
c      print*,' in makeMatrix',' max=', max,' mmax=',mmax

      do 10 i=1,max
        imax=i
        do 15 k=1,i
        sum=0.0
        kmax=k
c         if (( i .ge. 1) .or. (k .ge. 1 )) then
        if (( i .eq. 1) .or. (k .eq. 1 )) then
          sum1=0.0
          sum2=0.0
          kmin=kmax
        else
          sum=scr(i-1,k-1)
          kmin=1
        end if
        do 203 kk=1,kmin

          sum=sum+f(imax+1-kk)*f(kmax+1-kk)
203     continue
        scr(i,k)=sum
        scr(k,i)=sum

15      continue

10    continue
c
c  select row/columns
c
      do 20 i=1,nobs
        krow=irow(i)
        do 25 j=1,i
        kcol=irow(j)
        covar(i,j)=scr(krow,kcol)
        covar(j,i)=scr(kcol,krow)
25      continue
20    continue


c
c   flip matrix for inverse covariance
c
      if (iflip .ne. 0 ) then
        nobs2=int(nobs/2)
        idif=nobs-2*nobs2
c   idif=0 then, nobs is even; idif=1 then nobs is odd
        do 30 i=1,nobs2
          do 31 j=1,nobs
          tmp=covar(nobs+1-i,nobs+1-j)
          covar(nobs+1-i,nobs+1-j)=covar(j,i)
          covar(j,i)=tmp
31        continue
30      continue
        if (idif .ne. 0) then
          i=nobs2+1
          do 32 j=1,nobs
            tmp=covar(nobs+1-i,nobs+1-j)
            covar(nobs+1-i,nobs+1-j)=covar(j,i)
            covar(j,i)=tmp
32        continue            
        end if

      end if


      return
      end
